﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ID As String
	Public a As HTMLElement
	Public Theme As String
	Public Enabled As Boolean
	Public TextVisible As Boolean
	Public Text As String
	Private Theme As String
	Public HREF As String
	Public AtBottom As Boolean
	Public Click2Toggle As Boolean
	Public Horizontal As Boolean
	Public IsToolBar As Boolean
	Public Buttons As List
	Public IconName As String
	Public IconAlignment As String
	Public IconCircle As Boolean
	Public IconTheme As String
	Public WavesEffect As Boolean
	Public Visibility As String
	Public WavesType As String
	Public WavesCircle As Boolean
	Public Tooltip As String
	Public TooltipDelay As String
	Public ZDepth As String
	Public TooltipPosition As String
	Public Activator As Boolean
	Public Floating As Boolean
	Public Alignment As String
	Public InList As Boolean
	Public InLine As Boolean
	Private icnStyle As String
	Private itmStyle As String
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(itemID As String, itemIcon As String, itemIconAlign As String, itemIconCircle As Boolean, _
	itemText As String, itemNavigateTo As String, bTextVisible As Boolean, itemTheme As String, itemIconTheme As String,itemStyle As String, iconStyle As String)
	Alignment=""
	InList = False
	InLine = False
	Activator = False
	Floating = False
	ID = itemID.tolowercase
	HREF = itemNavigateTo
	TextVisible = bTextVisible
	Text = itemText
	Theme = itemTheme
	AtBottom = False
	Click2Toggle = False
	Horizontal = False
	IsToolBar = False
	Enabled = True
	Tooltip = ""
	Visibility = ""
	ZDepth = ""
	IconName = itemIcon
	IconAlignment = itemIconAlign
	IconTheme = itemIconTheme
	IconCircle = itemIconCircle
	Buttons.Initialize
	a.Initialize(ID,"a")
	WavesType=""
	WavesCircle = False
	WavesEffect = True
	itmStyle = itemStyle
	icnStyle = iconStyle
End Sub

Sub HTML As String
	'define the anchor
	a.ID = ID
	a.MaterialWavesEffect(WavesEffect)
	a.SetHRef(HREF)
	MashPlugIns.MaterialUseTheme(Theme,a)
	a.MaterialEnable(Enabled).ApplyStyle(itmStyle)
	a.MaterialZDepth(ZDepth)
	a.MaterialVisibility(Visibility)
	a.MaterialSetToolTip(TooltipPosition,TooltipDelay,Tooltip)
	a.MaterialAddIcon(IconName,IconAlignment,IconTheme,IconCircle,False,False,False,False,icnStyle)
	a.MaterialWavesType(WavesType)
	a.MaterialWavesCircle(WavesCircle)
	a.AddClassOnCondition(Activator,"activator")
	a.AddClassOnCondition(Floating, "btn-floating")
	a.AddClass(Alignment)
	If TextVisible = True Then a.AddContent(Text)
	If AtBottom = True Then
		Dim fab As HTMLElement
		fab.Initialize("","div").AddClass("fixed-action-btn").AddContent(a.HTML)
		fab.MaterialClick2Toggle(Click2Toggle).MaterialHorizontal(Horizontal).MaterialToolBar(IsToolBar)
		fab.AddStyleAttribute("right","24px")
		If Horizontal = True Then
			fab.AddStyleattribute("position","absolute")
		Else
			fab.AddStyleattribute("bottom","45px")
		End If
		Dim li As HTMLElement
		li.Initialize("","ul")
		For Each strButton As String In Buttons
			li.AddContent(strButton)
		Next
		fab.AddContent(li.HTML)
		Return fab.html
	Else
		If InList = True Then
			Dim li As HTMLElement
			li.Initialize("","li")
			If InLine = True Then
				li.AddStyleAttribute("display","inline")
			End If
			li.AddContent(a.HTML)
			Return li.html
		Else
			Return a.html
		End If
	End If
End Sub