﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'wrapped by Anele 'Mashy' Mbanga for ABMaterial
'anele@mbangas.com
'NB: DONT EVER USE NUMERIC MAP KEYS
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Public Theme As String
	Public Element As HTMLElement
	Private Buttons As List
	Public Enabled As Boolean
	Public Visibility As String
	Public ZDepth As String
	Public WavesEffect As Boolean
	Public WavesType As String
	Public WavesCircle As Boolean
	Private page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Public Hoverable As Boolean
	Private ABM As ABMaterial
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

Public Sub Initialize(InternalPage As ABMPage, ID As String, ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	page = InternalPage
	compID = ID
	Theme = ""
	Element.Initialize(ID,"nav")
	Element.AddClass(ZDepth)
	Buttons.Initialize
	Enabled = True
	Theme = ""
	Visibility= ""
	ZDepth = ""
	WavesType= ""
	WavesEffect = False
	WavesCircle = False
	Theme = ThemeName
	JavaCalls.initialize
End Sub

Sub AddButton(btnID As String, btnText As String)
	Dim a As HTMLElement
	a.Initialize(btnID,"a").AddClass("breadcrumb").addspace.AddContent(btnText).AddCursor
	a.MaterialAddIcon("fa fa-angle-right","right","",False,True,False,False,False,"")
	a.MaterialWavesEffect(True).MaterialWavesLight(True)
	a.AddOnClickEventProperty(compID,a.id)
	Buttons.Add(a.HTML)
	'JavaCalls.Add(a.AddClickEvent(a.id,a.id))
End Sub



private Sub HTML As String
	Element.AddClass(ZDepth)
	Element.ID = compID
	MashPlugIns.MaterialUseTheme(Theme,Element)
	Element.MaterialVisibility(Visibility)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle)
	Element.MaterialWaveseffect(WavesEffect)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialEnable(Enabled).MaterialHoverable(Hoverable)
	
	Dim wrapper As HTMLElement
	wrapper.Initialize("","div").AddClass("nav-wrapper")
	
	Dim div As HTMLElement
	div.Initialize("","div").AddClass("col s12")
	div.AddContentList(Buttons)
	
	wrapper.AddContent(div.HTML)
	Element.AddContent(wrapper.HTML)
	Return Element.html.Replace(CRLF,"")
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	page = InternalPage
	compID = internalID
	ABM.ReplaceMyHTML(page,compID,HTML)
	Dim script As String = MashPlugIns.MvFromList(JavaCalls,"")
	InternalPage.ws.Eval(script, Array As String(compID))
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(page,compID,HTML)
	Dim script As String = MashPlugIns.MvFromList(JavaCalls,"")
	page.ws.Eval(script, Array As String(compID))
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	page = InternalPage
	compID = internalID
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

