﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'for tick intervals, you can use 	
'1 day', 'n days', '1 week',
'n weeks', '1 month', 'n months'

Sub Class_Globals
	Dim ABM As ABMaterial 'ignore
	Dim ABMComp As ABMCustomComponent
	Private SeriesObjects As List
	Private SeriesColors As List	
	Private mTitle As String
	Private mWidth As String = "100%"
	Private mHeight As String = "500px"
	Private SeriesOptions As List
	Private LegendLabels As List
	Private mChartType As String
	Private SeriesDefaultTicks As List
	Public barGroupMargin As Int = 4
	Public TopMargin As Int = 30
	Public BottomMargin As Int = 10
	Public RightMargin As Int = 10
	Public LeftMargin As Int = 30
	'Public SingleSeries As Boolean = False
	Public InitString As String
	Public SortTicks As Boolean = False
	Public stackSeries As Boolean = False
	Public Animate As Boolean = False
	Public AnimateReplot As Boolean = False
	Private hasLowerLimit As Boolean
	Private hasUpperLimit As Boolean
	Private hasDeadLine As Boolean
	Public ShowCompilationDate As Boolean
	Public IsResizable As Boolean
	Private Intervals As List
	Private IntervalColors As List
	Private NoSeriesOptions As Boolean
	
	Type fillBetweenObject(series1 As String, series2 As String, color As String)
	Type bandsObject(show As Boolean)
	Type barDirectionObject(vertical As String, horizontal As String)
	Type placementObject(outsideGrid As String)
	Type formatterObject(PercentTickFormatter As String)
	Type lineCapObject(sround As String, sbutt As String, square As String)
	Type verticalLineObject(name As String, x As Object,lineWidth As Int,r As Int,g As Int, b As Int, shadow As Boolean, lineCap As String, yOffset As Int)
	Type horizontalLineObject(y As Object,lineWidth As Int,r As Int,g As Int, b As Int, shadow As Boolean, lineCap As String)
	Type dashedHorizontalLineObject(y As Object,lineWidth As Int,r As Int,g As Int, b As Int, shadow As Boolean, lineCap As String, dashPattern As String)
	Type canvasOverlayObject(Show As Boolean, dashedHorizontalLine As dashedHorizontalLineObject, HorizontalLine As horizontalLineObject, VerticalLine As verticalLineObject)
	Type pointLabelsObject(Show As Boolean, Location As String,edgeTolerance As String)
	Type highLighterObject(Show As Boolean, sizeAdjust As Double, showMarker As Boolean, tooltipAxes As String, yvalues As Int, formatString As String, showLabel As Boolean, tooltipLocation As String)
	Type cursorObject(show As Boolean,tooltipLocation As String,zoom As Boolean, showToolTip As Boolean, looseZoom As Boolean)
	Type linePatternObject(dashed As String, dotted As String)
	Type markerStyleObject(diamond As String,circle As String, x As String)
	Type markerOptionsObject(style As String, size As Int, show As Boolean)
	Type tickOptionsObject(formatString As String, angle As Int, fontSize As String, formatter As String, showGridline As Boolean)
	Type animationObject(Show As Boolean, speed As String)
	Type trendlineObject(show As Boolean, color As String, typeof As String, lineWidth As String)
	Type legendRendererOptionsObject(numberRows As Int)
	Type legendObject(Location As String, Show As Boolean, placement As String, renderer As String, rendererOptions As legendRendererOptionsObject)
	Type rendererOptionsObject(smooth As Boolean,varyBarColor As Boolean, animation As animationObject, dataLabels As String, ShowDataLabels As Boolean, sectionMargin As Int, fill As Boolean, lineWidth As Int, bubbleGradients As Boolean, bubbleAlpha As Double, sliceMargin As Int, startAngle As Int, innerDiameter As Int, ringMargin As Int, shadow As Boolean, barMargin As String,fillToZero As Boolean,barDirection As String, label As String, showTickLabels As Boolean, sMin As String, sMax As String, labelPosition As String, labelHeightAdjust As String, intervalOuterRadius As String, barWidth As String, barPadding As String, highlightMouseOver As Boolean, tickInset As String, minorTicks As String, forceTickAt0 As Boolean, candleStick As Boolean, bandData As String, bands As bandsObject, alignTicks As Boolean, highlightMouseDown As Boolean, size As Int)
	Type ChartTypesObject(bar As String, line As String, pie As String, funnel As String, scatter As String, bubble As String,block As String, donut As String, barh As String)
	Type AxisObject(tickRenderer As String, sMin As String, sMax As String, renderer As String, label As String, pad As String, numberTicks As Int, ticks As List, tickOptions As tickOptionsObject, tickInterval As String, labelRenderer As String, drawMajorGridlines As Boolean, drawMinorGridlines As Boolean, drawMajorTickMarks As Boolean, rendererOptions As rendererOptionsObject,axisname As String,ticksName As String,useSeriesColor As Boolean, autoscale As Boolean, size As Int)
	Type seriesObject(pointLabels As pointLabelsObject, shadow As Boolean, showLine As Boolean, showMarker As Boolean, renderer As String, markerOptions As markerOptionsObject, rendererOptions As rendererOptionsObject, fill As Boolean, xAxis As String, yAxis As String, fillAndStroke As Boolean, bstep As Boolean, showAngle As String, showHighlight As String,trendline As trendlineObject, color As String, linePattern As String, lineWidth As Int,label As String,neighborThreshold As String, name As String, SeriesMap As Map, IsDataArray As Boolean, LowerBand As Map, HigherBand As Map, hasBands As Boolean, size As Int)
	Type RendererObject(LogAxisRenderer As String, CanvasAxisLabelRenderer As String, BarRenderer As String,CategoryAxisRenderer As String, DateAxisRenderer As String, FunnelRenderer As String, BubbleRenderer As String, BlockRenderer As String, PieRenderer As String, DonutRenderer As String, CanvasAxisTickRenderer As String, OHLCRenderer As String, EnhancedLegendRenderer As String, MeterGaugeRenderer As String, LineRenderer As String)
	Type gridObject(background As String, drawGridlines As Boolean,gridLineColor As String, gridLineWidth As Int, drawBorder As Boolean, shadow As Boolean)
	Public grid As gridObject
	Public fillBetween As fillBetweenObject
	Public seriesDefaults As seriesObject
	Public renderer As RendererObject
	Public chartType As ChartTypesObject
	Public linePattern As linePatternObject
	Public markerStyle As markerStyleObject	
	Public highLight As highLighterObject
	Public cursor As cursorObject
	Public legend As legendObject
	Public canvasOverlay As canvasOverlayObject
	Public yAxis As AxisObject
	Public y2Axis As AxisObject
	Public y3Axis As AxisObject
	Public y4Axis As AxisObject
	Public y5Axis As AxisObject
	Public y6Axis As AxisObject
	Public y7Axis As AxisObject
	Public y8Axis As AxisObject
	Public y9Axis As AxisObject
	Public xAxis As AxisObject
	Public x2Axis As AxisObject
	Public axesDefaults As AxisObject
	Public formatter As formatterObject
	Public placement As placementObject
	Type LocationObject(n As String, s As String, e As String, w As String, ne As String, nw As String, se As String, sw As String)
	Public Location As LocationObject
	Public lineCap As lineCapObject
	Public barDirection As barDirectionObject
	Public s1 As seriesObject
	Public s2 As seriesObject
	Public s3 As seriesObject
	Public s4 As seriesObject
	Public s5 As seriesObject
	Public s6 As seriesObject
	Public s7 As seriesObject
	Public s8 As seriesObject
	Public s9 As seriesObject
	Public s10 As seriesObject
End Sub

'add the 1st series to the chart
Sub AddSeries1()
	If s1.IsInitialized = False Then 
		InitializeSeries(s1,"s1")
	End If
	SeriesObjects.Add(s1)
End Sub

'add 2nd series
Sub AddSeries2()
	If s2.IsInitialized = False Then 
		InitializeSeries(s2,"s2")
	End If
	SeriesObjects.Add(s2)
End Sub

'add 3rd series
Sub AddSeries3()
	If s3.IsInitialized = False Then 
		InitializeSeries(s3,"s3")
	End If
	SeriesObjects.Add(s3)
End Sub

'add 4th series
Sub AddSeries4()
	If s4.IsInitialized = False Then 
		InitializeSeries(s4,"s4")
	End If
	SeriesObjects.Add(s4)
End Sub

'add 5th series
Sub AddSeries5()
	If s5.IsInitialized = False Then 
		InitializeSeries(s5,"s5")
	End If
	SeriesObjects.Add(s5)
End Sub


'add 6th series
Sub AddSeries6()
	If s6.IsInitialized = False Then 
		InitializeSeries(s6,"s6")
	End If
	SeriesObjects.Add(s6)
End Sub

'add 7th series
Sub AddSeries7()
	If s7.IsInitialized = False Then 
		InitializeSeries(s7,"s7")
	End If
	SeriesObjects.Add(s7)
End Sub

'add 8th series
Sub AddSeries8()
	If s8.IsInitialized = False Then 
		InitializeSeries(s8,"s8")
	End If
	SeriesObjects.Add(s8)
End Sub

'add 9th series
Sub AddSeries9()
	If s9.IsInitialized = False Then 
		InitializeSeries(s9, "s9")
	End If
	SeriesObjects.Add(s9)
End Sub

'add 10th series
Sub AddSeries10()
	If s10.IsInitialized = False Then 
		InitializeSeries(s10, "s10")
	End If
	SeriesObjects.Add(s10)
End Sub

Sub AddSeries(s As seriesObject)
	If s.name.Length = 0 Then
		Log("Series Name Error: " & s.label)
	End If
	SeriesObjects.Add(s)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String)
	ABMComp.Initialize("ABMComp", Me,  InternalPage, ID,"")
	'ABMComp.Visibility = ABM.VISIBILITY_HIDE_ALL ' hide the chart while loading
	' the automatic events will be raised on the page e.g. if the id = "mycomp" then the event will be mycomp_Click(params as Map)
	' future: we'll see if some other mechanisme is needed for non automatic events 
	Clear
	SetChartType("line")
End Sub

'clear the contents of the chart
Sub Clear
	NoSeriesOptions = False
	fillBetween.Initialize
	fillBetween.color=""
	fillBetween.series1=""
	fillBetween.series2 = ""
	SeriesObjects.Initialize
	SeriesColors.Initialize
	barDirection.Initialize
	barDirection.horizontal = "horizontal"
	barDirection.vertical = "vertical"
	SeriesDefaultTicks.Initialize
	Intervals.Initialize
	IntervalColors.Initialize
	ShowCompilationDate = False
	IsResizable = False
	placement.Initialize
	placement.outsideGrid = "outsideGrid"
	LegendLabels.Initialize
	formatter.Initialize
	formatter.PercentTickFormatter = "$.jqplot.PercentTickFormatter"
	stackSeries = False
	grid.Initialize
	grid.background = ""
	grid.drawGridlines = True
	grid.gridLineColor = ""
	grid.gridLineWidth = -1
	grid.drawBorder = True
	grid.shadow = True
	hasLowerLimit = False
	hasUpperLimit = False
	hasDeadLine = False
	lineCap.Initialize
	lineCap.sbutt = "butt"
	lineCap.square = "square"
	lineCap.sround = "round"
	canvasOverlay.Initialize 
	canvasOverlay.show = False
	canvasOverlay.HorizontalLine.Initialize
	canvasOverlay.HorizontalLine.y = -1
	canvasOverlay.HorizontalLine.b = 0
	canvasOverlay.HorizontalLine.r = 0
	canvasOverlay.HorizontalLine.g = 0
	canvasOverlay.HorizontalLine.lineCap = ""
	canvasOverlay.HorizontalLine.shadow = False
	
	canvasOverlay.dashedHorizontalLine.Initialize
	canvasOverlay.dashedHorizontalLine.y = -1
	canvasOverlay.dashedHorizontalLine.b = 0
	canvasOverlay.dashedHorizontalLine.r = 0
	canvasOverlay.dashedHorizontalLine.g = 0
	canvasOverlay.dashedHorizontalLine.lineCap = ""
	canvasOverlay.dashedHorizontalLine.shadow = False
	canvasOverlay.dashedHorizontalLine.dashPattern = ""
	
	canvasOverlay.verticalLine.Initialize
	canvasOverlay.verticalLine.name = ""
	canvasOverlay.VerticalLine.x = 0
	canvasOverlay.verticalLine.yoffset = 0
	canvasOverlay.verticalLine.b = 0
	canvasOverlay.verticalLine.r = 0
	canvasOverlay.verticalLine.g = 0
	canvasOverlay.verticalLine.lineCap = ""
	canvasOverlay.verticalLine.shadow = False
	
	Location.Initialize
	Location.n = "n"
	Location.s = "s"
	Location.e = "e"
	Location.w = "w"
	Location.ne = "ne"
	Location.nw = "nw"
	Location.se = "se"
	Location.sw = "sw"
	stackSeries = False
	SortTicks = False
	legend.Initialize
	legend.location = ""
	legend.show = False
	legend.placement = ""
	legend.RendererOptions.Initialize
	legend.RendererOptions.numberRows = -1
	legend.renderer = ""
	highLight.Initialize
	highLight.show = False
	highLight.sizeAdjust = 0
	highLight.showMarker = True
	highLight.tooltipAxes = ""
	highLight.tooltiplocation = ""
	highLight.showLabel = False
	highLight.yvalues = 0
	highLight.formatString = ""
	cursor.Initialize
	cursor.show = False
	cursor.tooltipLocation = ""
	cursor.showToolTip = True
	cursor.looseZoom = False
	'SingleSeries = False
	markerStyle.Initialize
	markerStyle.circle = "circle"
	markerStyle.diamond = "diamond"
	markerStyle.x = "x"
	linePattern.Initialize
	linePattern.dashed = "dashed"
	linePattern.dotted = "dotted"
	renderer.Initialize
	renderer.LogAxisRenderer = "$.jqplot.LogAxisRenderer"
	renderer.CanvasAxisLabelRenderer = "$.jqplot.CanvasAxisLabelRenderer"
	renderer.BarRenderer = "$.jqplot.BarRenderer"
	renderer.CategoryAxisRenderer = "$.jqplot.CategoryAxisRenderer"
	renderer.DateAxisRenderer = "$.jqplot.DateAxisRenderer"
	renderer.FunnelRenderer = "$.jqplot.FunnelRenderer"
	renderer.BubbleRenderer = "$.jqplot.BubbleRenderer"
	renderer.BlockRenderer = "$.jqplot.BlockRenderer"
	renderer.PieRenderer = "$.jqplot.PieRenderer"
	renderer.DonutRenderer = "$.jqplot.DonutRenderer"
	renderer.CanvasAxisTickRenderer = "$.jqplot.CanvasAxisTickRenderer"
	renderer.OHLCRenderer = "$.jqplot.OHLCRenderer"
	renderer.EnhancedLegendRenderer = "$.jqplot.EnhancedLegendRenderer"
	renderer.MeterGaugeRenderer = "$.jqplot.MeterGaugeRenderer"
	renderer.LineRenderer = "$.jqplot.LineRenderer"
	chartType.Initialize
	chartType.bar = "bar"
	chartType.line = "line"
	chartType.pie = "pie"
	chartType.funnel = "funnel"
	chartType.scatter = "scatter"
	chartType.bubble = "bubble"
	chartType.block = "block"
	chartType.donut = "donut"
	chartType.barh = "barh"
	mChartType = chartType.line
	mTitle = ""
	mWidth = "100%"
	mHeight = "500px"
	barGroupMargin = 4
	TopMargin = 30
	BottomMargin  = 10
	RightMargin  = 10
	LeftMargin  = 30
	
	'********** axesDefaults
	InitializeAxis(axesDefaults)
	axesDefaults.axisname = "axesDefaults"

	'********** x axis
	InitializeAxis(xAxis)
	xAxis.axisname = "xaxis"
	xAxis.ticksName = "xticks"
	
	InitializeAxis(x2Axis)
	x2Axis.axisname = "x2axis"
	x2Axis.ticksName = "x2ticks"
	
	'******** y axis
	InitializeAxis(yAxis)
	yAxis.axisname = "yaxis"
	yAxis.ticksName = "yticks"
	
	'******** y2 axis
	InitializeAxis(y2Axis)
	y2Axis.axisname = "y2axis"
	y2Axis.ticksName = "y2ticks"
	
	InitializeAxis(y3Axis)
	y3Axis.axisname = "y3axis"
	y3Axis.ticksName = "y3ticks"
		
	'********** initialize series
	InitializeSeries(seriesDefaults,"seriesDefaults")
	InitializeSeries(s1,"s1")
	InitializeSeries(s2,"s2")
	InitializeSeries(s3,"s3")
	InitializeSeries(s4,"s4")
	InitializeSeries(s5,"s5")
	InitializeSeries(s6,"s6")
	InitializeSeries(s7,"s7")
	InitializeSeries(s8,"s8")
	InitializeSeries(s9,"s9")
	InitializeSeries(s10,"s10")
	SeriesOptions.Initialize
	 
End Sub

'initialize an axis
Sub InitializeAxis(axis As AxisObject)
	axis.Initialize
	axis.axisname = "xaxis"
	axis.renderer = ""
	axis.label = ""
	axis.pad = ""
	axis.sMax = ""
	axis.useSeriesColor = False
	axis.autoscale = False
	axis.size = 0
	axis.sMin = ""
	axis.drawMajorGridlines = True
	axis.drawMinorGridlines = True
	axis.drawMajorTickMarks = True
	axis.numberTicks = 0
	axis.ticks.Initialize
	axis.tickRenderer = ""
	axis.tickOptions.Initialize
	axis.tickOptions.formatString = ""
	axis.tickOptions.fontSize = ""
	axis.tickOptions.angle = 361
	axis.tickOptions.formatter = ""
	axis.tickOptions.showGridline = True
	axis.tickInterval = ""
	axis.labelRenderer = ""
	axis.rendererOptions.Initialize 
	axis.rendererOptions.tickInset = ""
	axis.rendererOptions.minorTicks = ""
	axis.rendererOptions.forceTickAt0 = False
	axis.rendererOptions.alignTicks = False
	axis.rendererOptions.size = 0	
End Sub

'initialize a series
Sub InitializeSeries(s As seriesObject, sname As String)
	s.Initialize
	s.name = sname
	s.pointLabels.Initialize
	s.pointLabels.show = False
	s.pointLabels.location = ""
	s.pointLabels.edgeTolerance = ""
	s.showMarker = True
	s.fillAndStroke = False
	s.showLine = True
	s.renderer = ""
	s.shadow = True
	s.fill = False
	s.xAxis = ""
	s.yAxis = ""
	s.bstep = False
	s.markerOptions.Initialize
	s.markerOptions.show = True
	s.showAngle = ""
	s.showHighlight = True
	s.rendererOptions.Initialize
	s.rendereroptions.varyBarColor = False
	s.rendereroptions.smooth = False
	s.rendererOptions.candleStick = False
	s.rendererOptions.animation.Initialize
	s.rendererOptions.animation.show = False
	s.rendererOptions.animation.speed = ""
	s.rendererOptions.bubbleGradients = False
	s.rendererOptions.bubbleAlpha = -1
	s.rendererOptions.label = ""
	s.rendererOptions.dataLabels = ""
	s.rendererOptions.showDataLabels = False
	s.rendererOptions.sectionMargin = -1
	s.rendererOptions.fill = True
	s.rendererOptions.lineWidth = -1
	s.rendererOptions.sliceMargin = -1
	s.rendererOptions.barMargin = ""
	s.rendererOptions.barWidth = ""
	s.rendererOptions.barPadding = ""
	s.rendererOptions.highlightMouseOver = True
	s.rendererOptions.highlightMouseDown = False
	s.rendererOptions.tickInset = ""
	s.rendererOptions.minorTicks = ""
	s.rendererOptions.forceTickAt0 = False
	s.rendererOptions.fillToZero = False  ' detect negative values by default
	s.rendererOptions.barDirection = ""
	s.rendererOptions.smin = ""
	s.rendererOptions.smax = ""
	s.rendererOptions.showTickLabels = True
	s.rendererOptions.labelPosition = ""
	s.rendererOptions.labelHeightAdjust = ""
	s.rendererOptions.intervalOuterRadius = ""
	s.rendererOptions.bandData = ""
	s.rendererOptions.bands.Initialize
	s.rendererOptions.bands.show = False
	s.rendererOptions.alignTicks = False
	s.rendererOptions.size = 0
	s.trendline.Initialize
	s.trendline.color = ""
	s.trendline.Show = False
	s.trendline.typeof = ""
	s.trendline.lineWidth = ""
	s.color = ""
	s.linePattern = ""
	s.lineWidth = -1
	s.label = ""
	s.neighborThreshold = ""
	s.SeriesMap.Initialize
	s.LowerBand.Initialize
	s.HigherBand.Initialize
	s.IsDataArray = False
	s.hasBands = False
	s.size = 0
End Sub

'Set SetFillBetween
Sub SetFillBetween(ser1 As String, ser2 As String, color As String)
	fillBetween.series1 = ser1
	fillBetween.series2 = ser2
	fillBetween.color = color
End Sub


'show bands for a series
Sub ShowSeriesBands(s As seriesObject)
	s.rendererOptions.bands.show = True
End Sub

'set the series color
Sub SetSeriesColor(s As seriesObject, color As String)
	s.color = color
End Sub

'Add SeriesDefaultTicks
Sub AddSeriesDefaultTicks(tick As String)
	SeriesDefaultTicks.Add(tick)
End Sub

'Add Series Interval & IntervalColor
Sub AddSeriesDefaultsInterval(interval As String, intervalColor As String)
	intervalColor = "'" & intervalColor & "'"
	Intervals.Add(interval)
	IntervalColors.Add(intervalColor)
End Sub

'set the deadline for the series
Sub SetDeadLine(name As String, x As Object,lineWidth As Int,r As Int,g As Int, b As Int, shadow As Boolean, slineCap As String, yOffset As Int)
	canvasOverlay.show = True
	hasDeadLine = True
	canvasOverlay.verticalLine.name = name
	canvasOverlay.VerticalLine.x = x
	canvasOverlay.verticalLine.yoffset = yOffset
	canvasOverlay.VerticalLine.lineWidth = lineWidth
	canvasOverlay.verticalLine.b = b
	canvasOverlay.verticalLine.r = r
	canvasOverlay.verticalLine.g = g
	canvasOverlay.verticalLine.lineCap = slineCap
	canvasOverlay.verticalLine.shadow = shadow
End Sub

'smooth all chart series
Sub Smoothen
	seriesDefaults.rendererOptions.smooth = True
End Sub

'hide all markers in series
Sub HideMarkers
	seriesDefaults.showMarker = False
End Sub

'animate all series
Sub Animated
	seriesDefaults.rendererOptions.animation.Show = True
End Sub

'show point labels
Sub ShowPointLabels(bs As Boolean, slocation As String)
	seriesDefaults.pointLabels.show = bs
	seriesDefaults.pointLabels.location = slocation
End Sub

'set bar margins
Sub SetBarMargins(iMargin As String)
	seriesDefaults.rendererOptions.barMargin = iMargin
End Sub

Sub SetCanvasAxisLabelRenderer
	axesDefaults.labelRenderer = renderer.CanvasAxisLabelRenderer
End Sub

'Rotate the XAxis Labels
Sub RotateXAxisLabels(iAngle As Int, fontSize As String)
	xAxis.tickRenderer = renderer.CanvasAxisTickRenderer
	xAxis.tickOptions.angle = iAngle
	xAxis.tickOptions.fontSize = fontSize	
End Sub

'set start angle
Sub SetStartAngle(ia As Int)
	seriesDefaults.rendererOptions.startAngle = ia
End Sub

'add ohlc data
Sub AddSeriesDataOHLC(timestamp As String, sopen As String, smax As String, smin As String, sclose As String)
	s1.IsDataArray = True
	timestamp = "'" & timestamp & "'"
	AddData2Series5(s1,timestamp,sopen,smax,smin,sclose)
End Sub

Sub AddSeriesDataOHLC1(s As seriesObject,timestamp As String, sopen As String, smax As String, smin As String, sclose As String)
	s.IsDataArray = True
	timestamp = "'" & timestamp & "'"
	AddData2Series5(s,timestamp,sopen,smax,smin,sclose)
End Sub


'add ohlc data
Sub AddSeriesDataOHLCCompare(index As String, sopen As String, smax As String, smin As String, sclose As String)
	s1.IsDataArray = True
	AddData2Series5(s1,index,sopen,smax,smin,sclose)
End Sub

Sub AddSeriesDataOHLCCompare1(s As seriesObject,index As String, sopen As String, smax As String, smin As String, sclose As String)
	s.IsDataArray = True
	AddData2Series5(s,index,sopen,smax,smin,sclose)
End Sub


'set fill for chart
Sub SetFill(bFill As Boolean, lineWidth As Int)
	seriesDefaults.rendererOptions.fill = bFill
	seriesDefaults.rendererOptions.lineWidth = lineWidth
End Sub

'set legend location and visibility
Sub SetLegend(slocation As String, bShow As Boolean, sPlacement As String)
	legend.location = slocation
	legend.show = bShow
	legend.placement = sPlacement
End Sub

'what happens when a mouse pointer is placed over a point, show details
Sub SetHighlighter(bShow As Boolean, sizeAdjust As Double)
	highLight.show = bShow
	highLight.sizeAdjust = sizeAdjust
End Sub

'set data labels for a funnel
Sub SetDataLabels(dataLabel As String, bShow As Boolean)
	seriesDefaults.rendererOptions.dataLabels = dataLabel
	seriesDefaults.rendererOptions.showDataLabels = bShow
End Sub

'No spacing between funnel values
Sub SetFunnelSectionMargin(iMargin As Int)
	seriesDefaults.rendererOptions.sectionMargin = iMargin
End Sub

'set the cursor visibility and tooltip location
Sub SetCursor(bShow As Boolean, sToolTipLocation As String)
	cursor.show = bShow
	cursor.tooltipLocation = sToolTipLocation
End Sub


'set XAxisTickOptionsFormatString
Sub SetXAxisTickOptionsFormatString(fs As String)
	xAxis.tickOptions.formatString = fs
End Sub

'set YAxisTickOptionsFormatString
Sub SetYAxisTickOptionsFormatString(fs As String)
	yAxis.tickOptions.formatString = fs
End Sub

'show lines or not
Sub ShowLines(bl As Boolean)
	seriesDefaults.showLine = bl
End Sub

'show markers or not
Sub ShowMarkers(bs As Boolean)
	seriesDefaults.showMarker = bs
End Sub

'has varying colors or not
Sub UseVaryingColors(bv As Boolean)
	seriesDefaults.rendererOptions.varyBarColor = bv
End Sub

'is chart smooth or not
Sub IsSmooth(bs As Boolean)
	seriesDefaults.rendererOptions.smooth = bs
End Sub

'is chart animated or not
Sub IsAnimated(bv As Boolean, bAnimate As Boolean, bAnimateReplot As Boolean)
	seriesDefaults.rendererOptions.animation.show = bv
	Animate = bAnimate
	AnimateReplot = bAnimateReplot
End Sub

'set the min and max for y axis
'this is the starting point on x axis and ending point
Sub SetYAxisMinMax(sMin As String, sMax As String)
	yAxis.sMin = sMin
	yAxis.sMax = sMax
End Sub

'set the min and max for y axis
'this is the starting point on x axis and ending point
Sub SetY3AxisMinMax(sMin As String, sMax As String)
	y3Axis.sMin = sMin
	y3Axis.sMax = sMax
End Sub


'set the width and height of the chart
Sub SetWidthHeight(Width As String, Height As String)
	mHeight = Height
	mWidth = Width
End Sub

'set the title of the chart
Sub SetTitle(Title As String)
	mTitle = Title
End Sub

'set all titles
Sub SetTitles(Title As String, xAxisTitle As String, yAxisTitle As String)
	mTitle = Title
	xAxis.label = xAxisTitle
	yAxis.label = yAxisTitle
End Sub

'set titles for x axis and y axis
Sub SetAxisTitles(xAxisTitle As String, yAxisTitle As String)
	xAxis.label = xAxisTitle
	yAxis.label = yAxisTitle
End Sub

'add specific ticks to the x axis
Sub AddXAxisTick(v As Object)
	Select Case mChartType
	Case chartType.barh
		yAxis.ticks.Add(v)
	Case Else	
		xAxis.ticks.Add(v)
	End Select
End Sub

'add y axis tick
Sub AddYAxisTick(v As Int)
	yAxis.ticks.Add(v)
End Sub

'set the x axis title for the chart
Sub SetXAxisTitle(XAxisTitle As String)
	xAxis.label = XAxisTitle
End Sub

'set deafult marker options
Sub SeriesDefaultsMarkerOptionsShow(bv As Boolean)
	seriesDefaults.markerOptions.Show = bv
End Sub

'set XAxisRenderer
Sub SetXAxisRenderer(sRenderer As String)
	xAxis.renderer = sRenderer
End Sub

'set YAxisRenderer
Sub SetYAxisRenderer(sRenderer As String)
	yAxis.renderer = sRenderer
End Sub


'Set the y axis title for the chart
Sub SetYAxisTitle(YAxisTitle As String)
	yAxis.label = YAxisTitle
End Sub

'show the data labels
Sub ShowDataLabels(bv As Boolean)
	seriesDefaults.rendererOptions.showDataLabels = bv
End Sub

'show the data labels
Sub SetSliceMargin(iv As Int)
	seriesDefaults.rendererOptions.sliceMargin = iv
End Sub

private Sub NoRenderers
	axesDefaults.labelRenderer = ""
	xAxis.renderer = ""
	yAxis.renderer = ""
	x2Axis.renderer = ""
	y2Axis.renderer = ""
	xAxis.labelRenderer = ""
	x2Axis.labelRenderer = ""
	yAxis.labelrenderer = ""
	y2Axis.labelRenderer = ""
	y3Axis.labelRenderer = ""
End Sub

'set the chart type
Sub SetChartType(sChartType As String)
	NoRenderers
	mChartType = sChartType.tolowercase
	Select Case mChartType
	Case chartType.line
		seriesDefaults.renderer = renderer.LineRenderer
	Case chartType.barh
		yAxis.renderer = renderer.CategoryAxisRenderer
		seriesDefaults.rendererOptions.barDirection = "horizontal"
		seriesDefaults.renderer = renderer.BarRenderer
	Case chartType.donut
		seriesDefaults.renderer = renderer.DonutRenderer
	Case chartType.pie
		seriesDefaults.renderer = renderer.PieRenderer
	Case chartType.block
		seriesDefaults.renderer = renderer.BlockRenderer
	Case chartType.bubble
		seriesDefaults.renderer = renderer.BubbleRenderer
		seriesDefaults.shadow = True
		seriesDefaults.rendererOptions.bubbleGradients = True
	Case chartType.bar
		seriesDefaults.renderer = renderer.BarRenderer
		xAxis.renderer = renderer.CategoryAxisRenderer
	Case chartType.funnel
		seriesDefaults.renderer = renderer.FunnelRenderer
	Case chartType.scatter
		ShowLines(False)
		ShowMarkers(True)
	End Select
End Sub

'set series linepattern ,line width, marker style and showline
Sub AddSeriesOptions(s As seriesObject, slinePattern As String, iLineWidth As Int, sMarkerStyle As String, iMarkerSize As Int, showLine As Boolean)
	s.linePattern = slinePattern
	s.lineWidth = iLineWidth
	If s.markerOptions.IsInitialized = False Then s.markerOptions.Initialize
	s.markerOptions.style = sMarkerStyle
	s.markerOptions.size = iMarkerSize
	s.showLine = showLine
End Sub

'set series trendline
Sub AddSeriesTrendLine(s As seriesObject, bShow As Boolean, sColor As String, stypeOf As String, slineWidth As String)
	If s.trendline.IsInitialized = False Then s.trendline.Initialize
	s.trendline.Show = bShow
	s.trendline.color = sColor
	s.trendline.typeof = stypeOf
	s.trendline.lineWidth = slineWidth
End Sub

'set series label
Sub SetSeriesLabel(s As seriesObject, sName As String)
	s.label = sName
End Sub

'add series renderer and renderoption
Sub AddSeriesRenderer(s As seriesObject,rendererName As String, candleStick As Boolean)
	s.renderer = rendererName
	s.rendererOptions.candleStick = candleStick
End Sub

'set legend placement
Sub SetLegendPlacement(sPlacement As String)
	legend.Show = True
	legend.placement = sPlacement
End Sub

'set series categories
Sub AddCategory(categoryName As String)
	SortTicks = False
	categoryName = "'" & categoryName & "'"
	AddXAxisTick(categoryName)
End Sub

'set series columns
Sub AddColumn(columnName As String)
	AddCategory(columnName)
End Sub

'Add legend label
Sub AddLegendLabel(legendLabel As String)
	' turn it on
	legend.show = True
	legendLabel = "'" & legendLabel & "'"
	LegendLabels.Add(legendLabel)
End Sub


'add date data to series1
Sub AddSeriesDateData(sDate As String, value As String)
	s1.IsDataArray = True
	sDate = QUOTE & sDate & QUOTE
	AddData2Series2(s1,sDate,value)
End Sub

'add date data to any series
Sub AddSeriesDateData1(s As seriesObject,sDate As String, value As String)
	s.IsDataArray = True
	sDate = QUOTE & sDate & QUOTE
	AddData2Series2(s,sDate,value)
End Sub

'add bubble chart data
Sub AddBubbleData(s As seriesObject, x As String, y As String, radius As String, label As String)
	s.IsDataArray = True
	label = QUOTE & label & QUOTE
	AddData2Series4(s,x,y,radius,label)
End Sub

'add bubble data with color
Sub AddBubbleDataWithColor(s As seriesObject,x As String, y As String, radius As String, label As String, color As String)
	s.IsDataArray = True
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{label: '").Append(label).Append("',color: '").Append(color).Append("'}")
	AddData2Series4(s,x,y,radius,sb.tostring)
End Sub

'add block data
Sub AddBlockData(s As seriesObject,x As String, y As String, label As String)
	s.IsDataArray = True
	label = "'" & label & "'"
	AddData2Series3(s,x,y,label)
End Sub

Sub AddData2Series10(so As seriesObject, v1 As Object, v2 As Object, v3 As Object, v4 As Object, v5 As Object, v6 As Object, v7 As Object, v8 As Object, v9 As Object, v10 As Object)
	Dim sValue As String
	Dim nLine As String
	Dim sb As StringBuilder
	Select Case mChartType
	Case chartType.barh
		sb.Initialize 
		sb.Append("[").Append(v1).Append(", 1]")
		sb.Append("[").Append(v2).Append(", 2]")
		sb.Append("[").Append(v3).Append(", 3]")
		sb.Append("[").Append(v4).Append(", 4]")
		sb.Append("[").Append(v5).Append(", 5]")
		sb.Append("[").Append(v6).Append(", 6]")
		sb.Append("[").Append(v7).Append(", 7]")
		sb.Append("[").Append(v8).Append(", 8]")
		sb.Append("[").Append(v9).Append(", 9]")
		sb.Append("[").Append(v10).Append(", 10]")
		nLine = "[" & sb.ToString & "]"
	Case Else
		nLine = $"[${v1}, ${v2}, ${v3}, ${v4}, ${v5}, ${v6}, ${v7}, ${v8}, ${v9}, ${v10}]"$
	End Select
	sValue = so.SeriesMap.GetDefault(so.Name, "")
	If sValue.Length = 0 Then
		sValue = nLine
	Else
		sValue = sValue & "," & nLine
	End If	
	so.SeriesMap.Put(so.Name,sValue)
End Sub

Sub AddData2Series9(so As seriesObject, v1 As Object, v2 As Object, v3 As Object, v4 As Object, v5 As Object, v6 As Object, v7 As Object, v8 As Object, v9 As Object)
	Dim sValue As String
	Dim nLine As String
	Dim sb As StringBuilder
	Select Case mChartType
	Case chartType.barh
		sb.Initialize 
		sb.Append("[").Append(v1).Append(", 1]")
		sb.Append("[").Append(v2).Append(", 2]")
		sb.Append("[").Append(v3).Append(", 3]")
		sb.Append("[").Append(v4).Append(", 4]")
		sb.Append("[").Append(v5).Append(", 5]")
		sb.Append("[").Append(v6).Append(", 6]")
		sb.Append("[").Append(v7).Append(", 7]")
		sb.Append("[").Append(v8).Append(", 8]")
		sb.Append("[").Append(v9).Append(", 9]")
		nLine = "[" & sb.ToString & "]"
	Case Else
		nLine = $"[${v1}, ${v2}, ${v3}, ${v4}, ${v5}, ${v6}, ${v7}, ${v8}, ${v9}]"$
	End Select
	sValue = so.SeriesMap.GetDefault(so.Name, "")
	If sValue.Length = 0 Then
		sValue = nLine
	Else
		sValue = sValue & "," & nLine
	End If	
	so.SeriesMap.Put(so.Name,sValue)
End Sub

Sub AddData2Series8(so As seriesObject, v1 As Object, v2 As Object, v3 As Object, v4 As Object, v5 As Object, v6 As Object, v7 As Object, v8 As Object)
	Dim sValue As String
	Dim nLine As String
	Dim sb As StringBuilder
	Select Case mChartType
	Case chartType.barh
		sb.Initialize 
		sb.Append("[").Append(v1).Append(", 1]")
		sb.Append("[").Append(v2).Append(", 2]")
		sb.Append("[").Append(v3).Append(", 3]")
		sb.Append("[").Append(v4).Append(", 4]")
		sb.Append("[").Append(v5).Append(", 5]")
		sb.Append("[").Append(v6).Append(", 6]")
		sb.Append("[").Append(v7).Append(", 7]")
		sb.Append("[").Append(v8).Append(", 8]")
		nLine = "[" & sb.ToString & "]"
	Case Else
		nLine = $"[${v1}, ${v2}, ${v3}, ${v4}, ${v5}, ${v6}, ${v7}, ${v8}]"$
	End Select
	sValue = so.SeriesMap.GetDefault(so.Name, "")
	If sValue.Length = 0 Then
		sValue = nLine
	Else
		sValue = sValue & "," & nLine
	End If	
	so.SeriesMap.Put(so.Name,sValue)
End Sub

Sub AddData2Series7(so As seriesObject, v1 As Object, v2 As Object, v3 As Object, v4 As Object, v5 As Object, v6 As Object, v7 As Object)
	Dim sValue As String
	Dim nLine As String
	Dim sb As StringBuilder
	Select Case mChartType
	Case chartType.barh
		sb.Initialize 
		sb.Append("[").Append(v1).Append(", 1]")
		sb.Append("[").Append(v2).Append(", 2]")
		sb.Append("[").Append(v3).Append(", 3]")
		sb.Append("[").Append(v4).Append(", 4]")
		sb.Append("[").Append(v5).Append(", 5]")
		sb.Append("[").Append(v6).Append(", 6]")
		sb.Append("[").Append(v7).Append(", 7]")
		nLine = "[" & sb.ToString & "]"
	Case Else
		nLine = $"[${v1}, ${v2}, ${v3}, ${v4}, ${v5}, ${v6}, ${v7}]"$
	End Select
	sValue = so.SeriesMap.GetDefault(so.Name, "")
	If sValue.Length = 0 Then
		sValue = nLine
	Else
		sValue = sValue & "," & nLine
	End If	
	so.SeriesMap.Put(so.Name,sValue)
End Sub

Sub AddData2Series6(so As seriesObject, v1 As Object, v2 As Object, v3 As Object, v4 As Object, v5 As Object, v6 As Object)
	Dim sValue As String
	Dim nLine As String
	Dim sb As StringBuilder
	Select Case mChartType
	Case chartType.barh
		sb.Initialize 
		sb.Append("[").Append(v1).Append(", 1]")
		sb.Append("[").Append(v2).Append(", 2]")
		sb.Append("[").Append(v3).Append(", 3]")
		sb.Append("[").Append(v4).Append(", 4]")
		sb.Append("[").Append(v5).Append(", 5]")
		sb.Append("[").Append(v6).Append(", 6]")
		nLine = "[" & sb.ToString & "]"
	Case Else
		nLine = $"[${v1}, ${v2}, ${v3}, ${v4}, ${v5}, ${v6}]"$
	End Select
	sValue = so.SeriesMap.GetDefault(so.Name, "")
	If sValue.Length = 0 Then
		sValue = nLine
	Else
		sValue = sValue & "," & nLine
	End If	
	so.SeriesMap.Put(so.Name,sValue)
End Sub

Sub AddData2Series5(so As seriesObject, v1 As Object, v2 As Object, v3 As Object, v4 As Object, v5 As Object)
	Dim sValue As String
	Dim nLine As String
	Dim sb As StringBuilder
	Select Case mChartType
	Case chartType.barh
		sb.Initialize 
		sb.Append("[").Append(v1).Append(", 1]")
		sb.Append("[").Append(v2).Append(", 2]")
		sb.Append("[").Append(v3).Append(", 3]")
		sb.Append("[").Append(v4).Append(", 4]")
		sb.Append("[").Append(v5).Append(", 5]")
		nLine = "[" & sb.ToString & "]"
	Case Else
		nLine = $"[${v1}, ${v2}, ${v3}, ${v4}, ${v5}]"$
	End Select
	sValue = so.SeriesMap.GetDefault(so.Name, "")
	If sValue.Length = 0 Then
		sValue = nLine
	Else
		sValue = sValue & "," & nLine
	End If	
	so.SeriesMap.Put(so.Name,sValue)
End Sub

Sub AddData2Series4(so As seriesObject, v1 As Object, v2 As Object, v3 As Object, v4 As Object)
	Dim sValue As String
	Dim nLine As String
	Dim sb As StringBuilder
	Select Case mChartType
	Case chartType.barh
		sb.Initialize 
		sb.Append("[").Append(v1).Append(", 1]")
		sb.Append("[").Append(v2).Append(", 2]")
		sb.Append("[").Append(v3).Append(", 3]")
		sb.Append("[").Append(v4).Append(", 4]")
		nLine = "[" & sb.ToString & "]"
	Case Else
		nLine = $"[${v1}, ${v2}, ${v3}, ${v4}]"$
	End Select
	sValue = so.SeriesMap.GetDefault(so.Name, "")
	If sValue.Length = 0 Then
		sValue = nLine
	Else
		sValue = sValue & "," & nLine
	End If	
	so.SeriesMap.Put(so.Name,sValue)
End Sub

Sub AddData2Series3(so As seriesObject, v1 As Object, v2 As Object, v3 As Object)
	Dim sValue As String
	Dim nLine As String
	Dim sb As StringBuilder
	Select Case mChartType
	Case chartType.barh
		sb.Initialize 
		sb.Append("[").Append(v1).Append(", 1]")
		sb.Append("[").Append(v2).Append(", 2]")
		sb.Append("[").Append(v3).Append(", 3]")
		nLine = "[" & sb.ToString & "]"
	Case Else
		nLine = $"[${v1}, ${v2}, ${v3}]"$
	End Select
	sValue = so.SeriesMap.GetDefault(so.Name, "")
	If sValue.Length = 0 Then
		sValue = nLine
	Else
		sValue = sValue & "," & nLine
	End If	
	so.SeriesMap.Put(so.Name,sValue)
End Sub

Sub AddData2Series2(so As seriesObject, v1 As Object, v2 As Object)
	Dim sValue As String
	Dim nLine As String
	Dim sb As StringBuilder
	Select Case mChartType
	Case chartType.barh
		sb.Initialize 
		sb.Append("[").Append(v1).Append(", 1]")
		sb.Append("[").Append(v2).Append(", 2]")
		nLine = "[" & sb.ToString & "]"
	Case Else
		so.IsDataArray = True
		nLine = $"[${v1}, ${v2}]"$
	End Select
	sValue = so.SeriesMap.GetDefault(so.Name, "")
	If sValue.Length = 0 Then
		sValue = nLine
	Else
		sValue = sValue & "," & nLine
	End If	
	so.SeriesMap.Put(so.Name,sValue)
End Sub

Sub AddSeriesData2Label(so As seriesObject,v1 As Object,v2 As Object)
	AddData2Series2Label(so,s1,s2)
End Sub

Sub AddData2Series2Label(so As seriesObject, v1 As Object, v2 As Object)
	so.IsDataArray = True
	v1 = "'" & v1 & "'"
	Dim sValue As String
	Dim nLine As String = $"[${v1}, ${v2}]"$
	sValue = so.SeriesMap.GetDefault(so.Name, "")
	If sValue.Length = 0 Then
		sValue = nLine
	Else
		sValue = sValue & "," & nLine
	End If	
	so.SeriesMap.Put(so.Name,sValue)
End Sub

Sub AddSeriesDataWithBands(so As seriesObject, v1 As Object, v2 As Object, lowBand As Object, highBand As Object)
	AddData2SeriesWithBands(so,v1,v2,lowBand,highBand)
End Sub

Sub AddData2SeriesWithBands(so As seriesObject, v1 As Object, v2 As Object, lowBand As Object, highBand As Object)
	Dim sValue As String
	Dim nLine As String = $"[${v1}, ${v2}]"$
	so.IsDataArray = True
	sValue = so.SeriesMap.GetDefault(so.Name, "")
	If sValue.Length = 0 Then
		sValue = nLine
	Else
		sValue = sValue & "," & nLine
	End If	
	so.SeriesMap.Put(so.Name,sValue)
	' add min band data
	Dim nLine As String = $"[${v1}, ${lowBand}]"$
	sValue = so.LowerBand.GetDefault(so.Name, "")
	If sValue.Length = 0 Then
		sValue = nLine
	Else
		sValue = sValue & "," & nLine
	End If	
	so.LowerBand.Put(so.Name,sValue)
	' add max band data
	Dim nLine As String = $"[${v1}, ${highBand}]"$
	sValue = so.higherBand.GetDefault(so.Name, "")
	If sValue.Length = 0 Then
		sValue = nLine
	Else
		sValue = sValue & "," & nLine
	End If	
	so.higherBand.Put(so.Name,sValue)
	so.hasBands = True
End Sub

Sub AddSeriesData1(so As seriesObject, v1 As Object)
	AddData2Series1(so,v1)
End Sub
Sub AddSeriesData2(so As seriesObject, v1 As Object,v2 As Object)
	AddData2Series2(so,v1,v2)
End Sub
Sub AddSeriesData3(so As seriesObject, v1 As Object,v2 As Object,v3 As Object)
	AddData2Series3(so,v1,v2,v3)
End Sub
Sub AddSeriesData4(so As seriesObject, v1 As Object,v2 As Object,v3 As Object,v4 As Object)
	AddData2Series4(so,v1,v2,v3,v4)
End Sub
Sub AddSeriesData5(so As seriesObject, v1 As Object,v2 As Object,v3 As Object,v4 As Object,v5 As Object)
	AddData2Series5(so,v1,v2,v3,v4,v5)
End Sub
Sub AddSeriesData6(so As seriesObject, v1 As Object,v2 As Object,v3 As Object,v4 As Object,v5 As Object,v6 As Object)
	AddData2Series6(so,v1,v2,v3,v4,v5,v6)
End Sub
Sub AddSeriesData7(so As seriesObject, v1 As Object,v2 As Object,v3 As Object,v4 As Object,v5 As Object,v6 As Object,v7 As Object)
	AddData2Series7(so,v1,v2,v3,v4,v5,v6,v7)
End Sub
Sub AddSeriesData8(so As seriesObject, v1 As Object,v2 As Object,v3 As Object,v4 As Object,v5 As Object,v6 As Object,v7 As Object,v8 As Object)
	AddData2Series8(so,v1,v2,v3,v4,v5,v6,v7,v8)
End Sub
Sub AddSeriesData9(so As seriesObject, v1 As Object,v2 As Object,v3 As Object,v4 As Object,v5 As Object,v6 As Object,v7 As Object,v8 As Object,v9 As Object)
	AddData2Series9(so,v1,v2,v3,v4,v5,v6,v7,v8,v9)
End Sub
Sub AddSeriesData10(so As seriesObject, v1 As Object,v2 As Object,v3 As Object,v4 As Object,v5 As Object,v6 As Object,v7 As Object,v8 As Object,v9 As Object,v10 As Object)
	AddData2Series10(so,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10)
End Sub


Sub AddData2Series1(so As seriesObject, v1 As Object)
	Dim sValue As String
	Dim nLine As String
	Dim sb As StringBuilder
	Select Case mChartType
	Case chartType.barh
		sb.Initialize 
		sb.Append("[").Append(v1).Append(", 1]")
		nLine = "[" & sb.ToString & "]"
	Case Else
		nLine = $"[${v1}]"$
	End Select
	sValue = so.SeriesMap.GetDefault(so.Name, "")
	If sValue.Length = 0 Then
		sValue = nLine
	Else
		sValue = sValue & "," & nLine
	End If	
	so.SeriesMap.Put(so.Name,sValue)
End Sub

'set the upper limit
Sub SetLowerLimit(y As Object,lineWidth As Int, r As Int, g As Int, b As Int, bShadow As Boolean, slineCap As String)
	hasLowerLimit = True
	canvasOverlay.show = True
	canvasOverlay.HorizontalLine.y = y
	canvasOverlay.HorizontalLine.b = b
	canvasOverlay.HorizontalLine.g = g
	canvasOverlay.HorizontalLine.r = r
	canvasOverlay.HorizontalLine.lineCap = slineCap
	canvasOverlay.HorizontalLine.shadow = bShadow
End Sub

'set the upper limit
Sub SetUpperLimit(y As Object,lineWidth As Int, r As Int, g As Int, b As Int, bShadow As Boolean, sDashPattern As String, slineCap As String)
	hasUpperLimit = True
	canvasOverlay.show = True
	canvasOverlay.dashedHorizontalLine.y = y
	canvasOverlay.dashedHorizontalLine.b = b
	canvasOverlay.dashedHorizontalLine.g = g
	canvasOverlay.dashedHorizontalLine.r = r
	canvasOverlay.dashedHorizontalLine.lineCap = slineCap
	canvasOverlay.dashedHorizontalLine.shadow = bShadow
	canvasOverlay.dashedHorizontalLine.dashPattern = sDashPattern
End Sub


'RGBA Color
public Sub GetRGBA(r As Int, g As Int, b As Int, a As Double) As String
	Dim sb As StringBuilder
	sb.Initialize 
	sb.Append("rgba(").Append(r).Append(",")
	sb.Append(g).Append(",").Append(b).Append(",").Append(a)
	sb.Append(")")
	Return sb.tostring
End Sub

Sub AddSeriesRGBA(s As seriesObject, r As Int, g As Int, b As Int, a As Double) As String
	SetSeriesColor(s,GetRGBA(r,g,b,a))
End Sub

Sub AddSeriesRGB(s As seriesObject, r As Int, g As Int, b As Int) As String
	SetSeriesColor(s,GetRGB(r,g,b))
End Sub


'RGBA Color
public Sub GetRGB(r As Int, g As Int, b As Int) As String
	Dim sb As StringBuilder
	sb.Initialize 
	sb.Append("rgb(").Append(r).Append(",")
	sb.Append(g).Append(",").Append(b)
	sb.Append(")")
	Return sb.tostring
End Sub

'set series fills
Sub AddSeriesFill(s As seriesObject, bValue As Boolean)
	s.fill = bValue
End Sub

'get the margins of the chart
private Sub GetMargins() As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("top:").Append(TopMargin).Append(",")
	sb.Append("right:").Append(RightMargin).Append(",")
	sb.Append("bottom:").Append(BottomMargin).Append(",")
	sb.Append("left:").Append(LeftMargin) 
	Return sb.tostring
End Sub

'build the options for the chart
private Sub GetOptions() As String
	Dim sb As StringBuilder
	sb.Initialize
#Region series.BandData
	For Each s As seriesObject In SeriesObjects
		If s.hasBands = True Then
			sb.Append("var ").Append(s.name).Append("Bands = [];").Append(CRLF)
			sb.Append("var ").Append(s.name).Append("lb = [];").Append(CRLF)
			sb.Append("var ").Append(s.name).Append("hb = [];").Append(CRLF)
			For Each strBand As String In s.LowerBand.Keys
				Dim strData As String = s.LowerBand.Get(strBand)
				sb.Append(s.name).Append("lb.push(").Append(strData).Append(");").Append(CRLF)
			Next
			For Each strBand As String In s.HigherBand.Keys
				Dim strData As String = s.HigherBand.Get(strBand)
				sb.Append(s.name).Append("hb.push(").Append(strData).Append(");").Append(CRLF)
			Next
			sb.Append(s.name).Append("Bands.push(").Append(s.name).Append("lb);").Append(CRLF)
			sb.Append(s.name).Append("Bands.push(").Append(s.name).Append("hb);").Append(CRLF)
		End If
	Next
#End Region	
	
#Region "seriesDefaults.renderOptions.ticks"
	If (SeriesDefaultTicks.size - 1) <> -1 Then
		sb.Append("var SeriesDefaultTicks = [];").Append(CRLF)
		For Each strTick As String In SeriesDefaultTicks 
			sb.Append("SeriesDefaultTicks.push(").Append(strTick).Append(");").Append(CRLF)
		Next
	End If	
#End Region	
	
#Region "seriesDefaults.intervals"
	If (Intervals.Size - 1) <> -1 Then
		sb.Append("var intervals = [];").Append(CRLF)
		For Each strInterval As String In Intervals 
			sb.Append("intervals.push(").Append(strInterval).Append(");").Append(CRLF)
		Next
	End If
#End Region
#Region "seriesDefaults.intervalColors"
	If (IntervalColors.Size - 1) <> -1 Then
		sb.Append("var intervalColors = [];").Append(CRLF)
		For Each strColor As String In IntervalColors 
			sb.Append("intervalColors.push(").Append(strColor).Append(");").Append(CRLF)
		Next
	End If
#End Region

#Region "Legend Labels"
	If (LegendLabels.Size - 1) <> -1 Then
		sb.Append("var legendLabels = [];").Append(CRLF)
		For Each strLabel As String In LegendLabels 
			sb.Append("legendLabels.push(").Append(strLabel).Append(");").Append(CRLF)
		Next
	End If
#End Region
	'define the ticks for the x axis
#Region "Build XAxis Ticks Array"
	If (xAxis.ticks.Size - 1) <> -1 Then
		If SortTicks = True Then xAxis.ticks.Sort(True)
		Dim sl As String = MvFromList(xAxis.ticks,",",False)
		sb.Append("var xticks = [").Append(sl).Append("];").Append(CRLF)
	End If
	If (x2Axis.ticks.Size - 1) <> -1 Then
		If SortTicks = True Then x2Axis.ticks.Sort(True)
		Dim sl As String = MvFromList(x2Axis.ticks,",",False)
		sb.Append("var x2ticks = [").Append(sl).Append("];").Append(CRLF)
	End If
#End Region
#Region "Build YAxis Ticks Array"
	'define the ticks for the y axis
	If (yAxis.ticks.Size - 1) <> -1 Then
		If SortTicks = True Then yAxis.ticks.Sort(True)
		Dim sl As String = MvFromList(yAxis.ticks,",",False)
		sb.Append("var yticks = [").Append(sl).Append("];").Append(CRLF)
	End If
#End Region
#Region "Build Y2Axis Ticks Array"
	'define the ticks for the y2 axis
	If (y2Axis.ticks.Size - 1) <> -1 Then
		If SortTicks = True Then y2Axis.ticks.Sort(True)
		Dim sl As String = MvFromList(y2Axis.ticks,",",False)
		sb.Append("var y2ticks = [").Append(sl).Append("];").Append(CRLF)
	End If
	If (y3Axis.ticks.Size - 1) <> -1 Then
		If SortTicks = True Then y3Axis.ticks.Sort(True)
		Dim sl As String = MvFromList(y3Axis.ticks,",",False)
		sb.Append("var y3ticks = [").Append(sl).Append("];").Append(CRLF)
	End If
#End Region
#Region "Build Series Colors Array"
	'define the series colors
	If (SeriesColors.Size - 1) <> -1 Then
		sb.Append("var sColors = [];").Append(CRLF)
		For Each strColor As String In SeriesColors
			sb.Append("sColors.push(").Append(strColor).Append(");").Append(CRLF)
		Next		
	End If
#End Region
#Region "Build Series Options Array"
	' define series options
	If mChartType = chartType.pie Or mChartType = chartType.donut Then
		SeriesOptions.Initialize
	End If
	If NoSeriesOptions = False Then SeriesOptions.Initialize
	If (SeriesOptions.Size - 1) <> -1 Then
		sb.Append("var sOptions = [];").Append(CRLF)
		For Each sOption As String In SeriesOptions
			sb.Append("sOptions.push(").Append(sOption).Append(");").Append(CRLF)
		Next
	End If
#End Region
#Region "Build Chart Options"
	sb.Append("var options = {").Append(CRLF)
		'define the title of the chart
#Region "Animate"
		If Animate = True Then
			sb.Append("animate: true,").append(CRLF)
		End If
		If AnimateReplot = True Then
			sb.Append("animateReplot: true,").Append(CRLF)
		End If
#End Region
#Region "Add Title"
		sb.Append("title: '").Append(mTitle).Append("'").Append(",").Append(CRLF)
#End Region
#Region "SeriesDefauls"
     	'define series defaults
		Dim sd As String = RenderSeries(seriesDefaults,True)
		If seriesDefaults.size > 0 Then
			sb.Append("seriesDefaults: ").Append(sd).Append(",").Append(CRLF)
		End If
#End Region
#Region "stackSeries"
		If stackSeries = True Then
			sb.Append("stackSeries: true, ").append(CRLF)
		End If
#End Region

#Region FillBetween
		If fillBetween.series1.Length > 0 And fillBetween.series2.Length > 0 And _
			fillBetween.color.Length > 0 Then
			sb.Append("fillBetween:{").Append(CRLF)
				sb.Append("series1 :").Append(fillBetween.series1).Append(",").Append(CRLF)
				sb.Append("series2 :").Append(fillBetween.series2).Append(",").Append(CRLF)
				sb.Append("color : ").Append(QUOTE).Append(fillBetween.color).Append(QUOTE).Append(")").Append(CRLF)
			sb.Append("},").Append(CRLF)
		End If
#End Region
#Region "Upper & Lower Limits"
		If canvasOverlay.show = True Then
			sb.Append("canvasOverlay: {").Append(CRLF)
				sb.Append("show: true,").Append(CRLF)
				sb.Append("objects: [").Append(CRLF)
					If hasLowerLimit = True Then
						sb.Append("{horizontalLine: {").Append(CRLF)
							sb.Append("y: ").Append(canvasOverlay.HorizontalLine.y).Append(",").Append(CRLF)
							sb.Append("lineWidth: ").Append(canvasOverlay.HorizontalLine.lineWidth).Append(",").Append(CRLF)
							sb.Append("color: 'rgb(").Append(canvasOverlay.HorizontalLine.r).Append(",")
							sb.Append(canvasOverlay.HorizontalLine.g).Append(",")
							sb.Append(canvasOverlay.HorizontalLine.b).Append(")',").Append(CRLF)
							sb.Append("shadow: ").Append(canvasOverlay.HorizontalLine.shadow).Append(",").Append(CRLF)
							sb.Append("lineCap: '").Append(canvasOverlay.HorizontalLine.lineCap).Append("'").append(CRLF)
						sb.Append("}},").Append(CRLF)
					End If
					If hasUpperLimit = True Then
						sb.Append("{dashedHorizontalLine: {").Append(CRLF)
							sb.Append("y: ").Append(canvasOverlay.dashedHorizontalLine.y).Append(",").Append(CRLF)
							sb.Append("lineWidth: ").Append(canvasOverlay.dashedHorizontalLine.lineWidth).Append(",").Append(CRLF)
							sb.Append("color: 'rgb(").Append(canvasOverlay.dashedHorizontalLine.r).Append(",")
							sb.Append(canvasOverlay.dashedHorizontalLine.g).Append(",")
							sb.Append(canvasOverlay.dashedHorizontalLine.b).Append(")',").Append(CRLF)
							sb.Append("shadow: ").Append(canvasOverlay.dashedHorizontalLine.shadow).Append(",").Append(CRLF)
							sb.Append("dashPattern: [").Append(canvasOverlay.dashedHorizontalLine.dashpattern).Append("],").Append(CRLF)
							sb.Append("lineCap: '").Append(canvasOverlay.dashedHorizontalLine.lineCap).Append("'").append(CRLF)
						sb.Append("}},").Append(CRLF)
					End If
					If hasDeadLine = True Then
						sb.Append("{verticalLine: {").Append(CRLF)
							sb.Append("name: '").Append(canvasOverlay.verticalLine.name).Append("',").Append(CRLF)
							sb.Append("x: ").Append(canvasOverlay.verticalLine.x).Append(",").Append(CRLF)
							sb.Append("lineWidth: ").Append(canvasOverlay.verticalLine.lineWidth).Append(",").Append(CRLF)
							sb.Append("color: 'rgb(").Append(canvasOverlay.verticalLine.r).Append(",")
							sb.Append(canvasOverlay.verticalLine.g).Append(",")
							sb.Append(canvasOverlay.verticalLine.b).Append(")',").Append(CRLF)
							sb.Append("shadow: ").Append(canvasOverlay.verticalLine.shadow).Append(",").Append(CRLF)
							sb.Append("yOffset: ").Append(canvasOverlay.verticalLine.yoffset).Append(",").Append(CRLF)
							sb.Append("lineCap: '").Append(canvasOverlay.verticalLine.lineCap).Append("'").append(CRLF)
						sb.Append("}},").Append(CRLF)
					End If
				sb.Append("]").Append(CRLF)
			sb.Append("},").Append(CRLF)
		End If
#End Region
#Region "Add Series Options"
		'define series options
		If (SeriesOptions.Size - 1) <> -1 Then
			sb.Append("series: sOptions").Append(",").Append(CRLF)
		End If
#End Region
#Region "Add Series Colors"
		'define the series colors
		If (SeriesColors.Size - 1) <> -1 Then
			sb.Append("seriesColors: sColors").Append(",").Append(CRLF)
		End If
#End Region
#End Region

#Region "Axes Defaults"		
			axesDefaults.axisname = "axesDefaults"
			axesDefaults.ticksName = ""
			Dim ad As String = RenderAxis(axesDefaults)
			If axesDefaults.size > 0 Then sb.Append(ad)
#End Region		

#Region "XYAxis"		
#Region XAxis
			xAxis.axisname = "xaxis"
			xAxis.ticksName = "xticks"
			Dim x As String = RenderAxis(xAxis)
			Dim xs As Int = xAxis.size
#End Region
		
#Region X2Axis
			x2Axis.axisname = "x2axis"
			x2Axis.ticksName = "x2ticks"
			Dim x2 As String = RenderAxis(x2Axis)
			Dim x2s As Int = x2Axis.size
#End Region

#Region YAxis
			yAxis.axisname = "yaxis"
			yAxis.ticksName = "yticks"
			Dim y As String = RenderAxis(yAxis)
			Dim ys As Int = yAxis.size
#End Region

#Region "Y2Axis"
			y2Axis.axisname = "y2axis"
			y2Axis.ticksName = "y2ticks"
			Dim y2 As String = RenderAxis(y2Axis)
			Dim y2s As Int = y2Axis.size
#End Region

#Region "Y3Axis"
			y3Axis.axisname = "y3axis"
			y3Axis.ticksName = "y3ticks"
			Dim y3 As String = RenderAxis(y3Axis)
			Dim y3s As Int = y3Axis.size

#End Region
			If xs > 0 Or x2s > 0 Or ys > 0 Or y2s > 0 Or y3s > 0 Then
				'define the axes default properties
				sb.Append("axes:{").Append(CRLF)
					If xs > 0 Then sb.Append(x)
					If x2s > 0 Then sb.Append(x2)
					If ys > 0 Then sb.Append(y)
					If y2s > 0 Then sb.Append(y2)
					If y3s > 0 Then sb.Append(y3)
				sb.Append("},").Append(CRLF)
			End If

#End Region

#Region "Grid"
			If (grid.drawGridlines = False) Or (grid.background.Length > 0) Or _
			(grid.gridLineColor.Length > 0) Or (grid.gridLineWidth <> -1) Or _
			(grid.drawBorder = False) Or (grid.shadow = False) Then
		sb.Append("grid:{").Append(CRLF)
			If grid.drawGridlines = False Then
				sb.Append("drawGridlines: false,").Append(CRLF)
			End If
			If grid.background.Length > 0 Then
				sb.Append("background: '").Append(grid.background).Append("',").Append(CRLF)
			End If
			If grid.gridLineColor.Length > 0 Then
				sb.Append("gridLineColor: '").Append(grid.gridLineColor).Append("',").Append(CRLF)
			End If
			If grid.gridLineWidth <> -1 Then
				sb.Append("gridLineWidth: ").Append(grid.gridLineWidth).Append(",").Append(CRLF)
			End If
			If grid.drawBorder = False Then
				sb.Append("drawBorder: false,").Append(CRLF)
			End If
			If grid.shadow = False Then
				sb.Append("shadow: false,").Append(CRLF)
			End If
		sb.Append("},").Append(CRLF)
		End If
#End Region
		
#Region "Highligher"		
			If highLight.Show = True Or highLight.sizeAdjust > 0 Or _
			highLight.showLabel = True Or highLight.tooltipAxes.Length > 0 Or _
			highLight.tooltipLocation.Length > 0 Then
			sb.Append("highlighter:{").Append(CRLF)
				If highLight.show = True Then
					sb.Append("show: ").Append(highLight.show).Append(",").Append(CRLF)
				End If
				If highLight.sizeAdjust > 0 Then
					sb.Append("sizeAdjust: ").Append(highLight.sizeAdjust).Append(",").Append(CRLF)
				End If
				If highLight.showLabel = True Then
					sb.Append("showLabel: ").Append(highLight.showLabel).Append(",").Append(CRLF)
				End If
				If highLight.tooltipAxes.length > 0 Then
					sb.Append("tooltipAxes: '").Append(highLight.tooltipAxes).Append("',").Append(CRLF)
				End If
				If highLight.tooltipLocation.length > 0 Then
					sb.Append("tooltipLocation: '").Append(highLight.tooltipLocation).Append("',").Append(CRLF)
				End If
			sb.Append("}").Append(",").Append(CRLF)
			End If
#End Region
		
#Region "Cursor"
			If cursor.show = True Or cursor.tooltipLocation.Length > 0 Or _
			cursor.zoom = True Or cursor.showToolTip = False Or cursor.looseZoom = True Then
			sb.Append("cursor:{").Append(CRLF)
				If cursor.show = True Then
					sb.Append("show: ").Append(cursor.show).Append(",").Append(CRLF)
				End If
				If cursor.tooltipLocation.Length > 0 Then
					sb.Append("tooltipLocation:'").Append(cursor.tooltipLocation).Append("'").Append(",")
					sb.Append(CRLF)
				End If
				If cursor.zoom = True Then
					sb.Append("zoom: true,").Append(CRLF)
				End If
				If cursor.showToolTip = False Then
					sb.Append("showTooltip: false,").Append(CRLF)
				End If
				If cursor.looseZoom = True Then
					sb.Append("looseZoom: true,").Append(CRLF)
				End If		
			sb.Append("}").Append(",").Append(CRLF)
			End If
#End Region
		
#Region "Legend"
			If legend.Location.Length > 0 Or legend.Show = True Or legend.placement.Length > 0 Or legend.renderer.Length > 0 Or _
				legend.rendererOptions.numberRows <> -1 Then
			sb.Append("legend:{").Append(CRLF)
#Region "Legend Labels"
			If (LegendLabels.Size - 1) <> -1 Then
				sb.Append("labels: legendLabels,").Append(CRLF)
			End If
#End Region
#Region "Legend.location"
				If legend.location.Length > 0 Then
					sb.Append("location: '").Append(legend.location).Append("'").Append(",")
					sb.Append(CRLF)
				End If
#End Region
#Region "Legend.show"
				If legend.show = True Then
					sb.Append("show: true,").Append(CRLF)
				End If
#End Region
#Region "Legend.placement"
				If legend.placement.Length > 0 Then
					sb.Append("placement: '").Append(legend.placement).Append("'")
					sb.Append(",").Append(CRLF)
				End If	
#End Region
#Region "Legend.renderer"
				If legend.renderer.Length > 0 Then
					sb.Append("renderer: ").Append(legend.renderer).Append(",").Append(CRLF)
				End If
#End Region
#Region "Legend.rendererOptions.numberofRows"
				sb.Append("rendererOptions: {").Append(CRLF)
					If legend.RendererOptions.numberRows <> -1 Then
						sb.Append("numberRows: ").Append(legend.rendererOptions.numberRows)
						sb.Append(",").Append(CRLF)
					End If
				sb.Append("},").Append(CRLF)
#End Region

			sb.Append("}").Append(CRLF)
			End If
#End Region

	sb.Append("};").Append(CRLF) 
	Return sb.tostring
#End Region
End Sub

'detect negative values in bar chart
Sub DetectNegativeValues(bd As Boolean)
	seriesDefaults.rendererOptions.fillToZero = bd
End Sub

'set up Bubble Chart properties
Sub SetBubbleChart(bShadow As Boolean, bBubbleGradients As Boolean, bubbleAlpha As Double)
	seriesDefaults.shadow = bShadow
	seriesDefaults.rendererOptions.bubbleGradients = bBubbleGradients
	seriesDefaults.rendererOptions.bubbleAlpha = bubbleAlpha
End Sub

'set the x axis numberticks
Sub SetXAxisNumberTicks(v As Int)
	xAxis.numberTicks = v	
End Sub

'set the x axis numberticks
Sub SetYAxisNumberTicks(v As Int)
	yAxis.numberTicks = v	
End Sub

'set the x axis min
Sub SetXAxisMin(sMin As String)
	xAxis.sMin = sMin
End Sub

'set the x axis min
Sub SetXAxisMax(sMax As String)
	xAxis.sMax = sMax	
End Sub

'set the x axis min
Sub SetYAxisMin(sMin As String)
	yAxis.sMin = sMin	
End Sub

Sub SetYAxisMax(sMax As Object)
	yAxis.smax = sMax	
End Sub

'set the x axis min max values
Sub SetXAxisMinMax(smin As String, smax As String)
	xAxis.sMin = smin	
	xAxis.sMax = smax	
End Sub

'set the y2axis min max
Sub SetY2AxisMinMax(smin As String, smax As String)
	y2Axis.sMin = smin	
	y2Axis.sMax = smax	
End Sub

'set the padding of the x axis
Sub SetXAxisPadding(v As Int)
	xAxis.pad = v
End Sub

'set the padding of the y axis
Sub SetYAxisPadding(v As Int)
	yAxis.pad = v
End Sub

'return the script of the control
public Sub ToString() As String
	Return GetScript(ABMComp.ID)
End Sub


'build the data for the chart
private Sub GetData() As String
	If (SeriesObjects.Size -1) = -1 Then
		Log("Error: No data provided")
		Return ""
	End If
	Dim dl As List
	dl.Initialize 
	Dim sm As Map
	sm.Initialize 
	Dim sb As StringBuilder
	sb.Initialize
	For Each s As seriesObject In SeriesObjects
		Dim strData As String
		For Each strKey As String In s.SeriesMap.Keys
			sm.Put(strKey,strKey)
			strData = s.SeriesMap.Get(strKey)
			If s.IsDataArray = True Then
				strData = "[" & strData & "]"
			End If
			sb.Append("var ").Append(strKey).Append(" = ").Append(strData).Append(";").Append(CRLF)
			dl.Add(strKey)
		Next
	Next
	Dim sl As String = MvFromList(dl,",",False)
	sb.Append("var data = [").Append(sl).Append("];").Append(CRLF)
	Return sb.tostring
End Sub

Sub MvFromList(lst As List, Delim As String, bQuote As Boolean) As String
	Dim lTot As Int
	Dim lCnt As Int
	Dim lStr As StringBuilder
	Dim ss As String
	lStr.Initialize
	lTot = lst.Size - 1
	For lCnt = 0 To lTot
		ss = lst.Get(lCnt)
		If bQuote = True Then ss = "'" & ss & "'"
		lStr.Append(ss)
		If lCnt <> lTot Then lStr.Append(Delim)
	Next
	Return lStr.tostring
End Sub

' runs when an object is created for the first time. Expects a valid html string
Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	Return $"<div id="${internalID}" style="height:"${mHeight}; width="${mWidth};"></div>"$
End Sub

private Sub BuildOptions
	Dim ant As Int = 0
	Dim str As String
	Dim strColor As String
	SeriesOptions.Initialize
	SeriesColors.Initialize
	For Each s As seriesObject In SeriesObjects
		str = RenderSeries(s,False)
		ant = ant + s.size
		If s.size = 0 Then
			SeriesOptions.Add("{}")
		Else
			SeriesOptions.Add(str)
		End If
		strColor = s.color
		If strColor.Length > 0 Then 
			strColor = "'" & strColor & "'"
			SeriesColors.Add(strColor)
		End If
	Next
	If ant = 0 Then
		NoSeriesOptions = False
	Else
		NoSeriesOptions = True
	End If
End Sub

'build the charting script
private Sub GetScript(internalID As String) As String
	BuildOptions
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append(GetData) 
	sb.Append(GetOptions)
	sb.Append(internalID & "plot = $.jqplot('").append(internalID).append("', data, options);").append(CRLF)
	If ShowCompilationDate = True Then
		sb.Append("// add a date at the bottom").Append(CRLF)
		sb.Append("var d = new $.jsDate();").Append(CRLF)
		sb.Append("$('div.jqplot-datestamp').html('Generated on '+d.strftime('%v'));").Append(CRLF)
	End If
	If IsResizable = True Then
		sb.Append("// make it resizable.").Append(CRLF)
		sb.Append("$(").Append(QUOTE).Append("div.chart-container").Append(QUOTE)
		sb.Append(").resizable({delay:20});").append(CRLF)
		sb.Append("$('div.chart-container').bind('resize', function(event, ui) {").Append(CRLF)
		sb.Append(internalID & "plot.replot();").Append(CRLF)
		sb.Append("});").Append(CRLF)
	End If
	Return sb.tostring
End Sub

' Is useful to run some initalisation script. 
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Dim script As String = GetScript(internalID)
	InternalPage.ws.Eval(script, Array As Object(ABMComp.ID))
	' flush not needed, it's done in the refresh method in the lib
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	' use these methods to adjust the object
	' ABM.HasClass
	' ABM.AddClass
	' ABM.RemoveClass
	
	' ABM.AddHTML
	' ABM.InsertHTMLAfter
	' ABM.RemoveHTML
	
	' ABM.GetProperty
	' ABM.SetProperty
	' ABM.RemoveProperty
	
	' ABM.GetStyleProperty
	' ABM.SetStyleProperty
	
	' do some script stuff like you do in RunJavaScript	
	'Dim script As String = ""
	'InternalPage.ws.Eval(script, Null)	
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
	
End Sub


private Sub RenderOptions(sobj As seriesObject, bIncludeLB As Boolean) As String
	Dim sb As StringBuilder
	sb.Initialize
	Dim sSize As Int = sobj.size
	Dim ro As Int = 0
	#Region "sobj.rendererOptions"
			sb.Append(CRLF)
			sb.Append("rendererOptions:{")
			If bIncludeLB = True Then sb.Append(CRLF)
#Region "sobj.renderOptions.bandData
				If sobj.hasBands = True Then
					sb.Append("bandData: ").Append(sobj.name).Append("Bands,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
				If sobj.rendererOptions.bands.show = True Then
					sb.Append("bands: {show: true},")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
				If sobj.rendererOptions.alignTicks = True Then
					sb.Append("alignTicks: true,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#Region "sobj.renderOptions.label"
				If sobj.rendererOptions.label.Length > 0 Then
					sb.Append("label: '").Append(sobj.rendererOptions.label).Append("',")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region "sobj.rendererOptions.barDirection"
				If sobj.rendererOptions.barDirection.Length > 0 Then
					sb.Append("barDirection: '").Append(sobj.rendererOptions.barDirection).Append("',")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
#Region "sobj.rendererOptions.fillToZero"
				If sobj.rendererOptions.fillToZero = True Then
					sb.Append("fillToZero: true,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
#Region "sobj.rendererOptions.barMargin"
				If sobj.rendererOptions.barMargin.length > 0 Then
					sb.Append("barMargin: ").Append(sobj.rendererOptions.barMargin).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
#Region "sobj.rendererOptions.barWidth"
				If sobj.rendererOptions.barWidth.length > 0 Then
					sb.Append("barWidth: ").Append(sobj.rendererOptions.barWidth).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
#Region "sobj.rendererOptions.barPadding"
				If sobj.rendererOptions.barPadding.length > 0 Then
					sb.Append("barPadding: ").Append(sobj.rendererOptions.barPadding).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
#Region "sobj.rendererOptions.highlightMouseOver"
				If sobj.rendererOptions.highlightMouseOver = False Then
					sb.Append("highlightMouseOver: false,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
				If sobj.rendererOptions.highlightMouseDown = True Then
					sb.Append("highlightMouseDown: true,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#Region "sobj.rendererOptions.tickInset"
				If sobj.rendererOptions.tickInset.length > 0 Then
					sb.Append("tickInset: ").Append(sobj.rendererOptions.tickInset).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
#Region "sobj.rendererOptions.minorTicks"
				If sobj.rendererOptions.minorTicks.length > 0 Then
					sb.Append("minorTicks: ").Append(sobj.rendererOptions.minorTicks).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region "sobj.rendererOptions.forceTickAt0"
				If sobj.rendererOptions.forceTickAt0 = True Then
					sb.Append("forceTickAt0: ").Append(sobj.rendererOptions.forceTickAt0).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region


#Region "sobj.rendererOptions.slideMargin"
				If sobj.rendererOptions.sliceMargin <> -1 Then
					sb.Append("sliceMargin: ").Append(sobj.rendererOptions.sliceMargin).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
#Region "sobj.rendererOptions.varyBarColor"
				If sobj.rendererOptions.varyBarColor = True Then
					sb.Append("varyBarColor: true,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region "sobj.rendererOptions.smooth"
				If sobj.rendererOptions.smooth = True Then
					sb.Append("smooth: true,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
#Region "sobj.rendererOptions.animation"
				If sobj.rendereroptions.animation.show = True Or sobj.rendererOptions.animation.speed.length > 0 Then
				sb.Append("animation: {")
				If bIncludeLB = True Then sb.Append(CRLF)
				If sobj.rendereroptions.animation.show = True Then
					sb.Append("show: true,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
				If sobj.rendererOptions.animation.speed.length > 0 Then
					sb.Append("speed: ")
					sb.Append(sobj.rendererOptions.animation.speed).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
				sb.Append("},")
				If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
#Region "sobj.rendererOptions.dataLabels"
				If sobj.rendererOptions.dataLabels.Length > 0 Then
					sb.Append("dataLabels: '").Append(sobj.rendererOptions.dataLabels).Append("',")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)				
				End If
#End Region
#Region "sobj.rendererOptions.showTickLabels"
				If sobj.rendererOptions.showTickLabels = False Then
					sb.Append("showTickLabels: false,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
#Region "sobj.rendererOptions.min"
				If sobj.rendererOptions.sMin.Length > 0 Then
					sb.Append("min: ").Append(sobj.rendererOptions.sMin).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
#Region "sobj.rendererOptions.max"
				If sobj.rendererOptions.smax.Length > 0 Then
					sb.Append("max: ").Append(sobj.rendererOptions.smax).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region "sobj.rendererOptions.labelPosition"
				If sobj.rendererOptions.labelPosition.Length > 0 Then
					sb.Append("labelPosition: '").Append(sobj.rendererOptions.labelPosition).Append("',")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region "sobj.rendererOptions.labelHeightAdjust"
				If sobj.rendererOptions.labelHeightAdjust.Length > 0 Then
					sb.Append("labelHeightAdjust: ").Append(sobj.rendererOptions.labelHeightAdjust).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region "sobj.rendererOptions.intervalOuterRadius"
				If sobj.rendererOptions.intervalOuterRadius.Length > 0 Then
					sb.Append("intervalOuterRadius: ")
					sb.Append(sobj.rendererOptions.intervalOuterRadius).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region sobj.renderOptions.ticks
				If (SeriesDefaultTicks.size - 1) <> -1 Then
					sb.Append("ticks: SeriesDefaultTicks,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region "sobj.rendererOptions.intervals"
				If (Intervals.Size - 1) <> -1 Then 
					sb.Append("intervals: intervals,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
#Region "sobj.rendererOptions.intervalColors"
				If (IntervalColors.Size - 1) <> -1 Then 
					sb.Append("intervalColors: intervalColors,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region series.renderOptions.candleStick
				If sobj.rendererOptions.candleStick = True Then
					sb.Append("candleStick: true,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region "sobj.rendererOptions.showDataLabels"
				If sobj.rendererOptions.showDataLabels = True Then
					sb.Append("showDataLabels: true,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region "sobj.rendererOptions.sectionMargin"
				If sobj.rendererOptions.sectionMargin <> -1 Then
					sb.Append("sectionMargin: ").Append(sobj.rendererOptions.sectionMargin).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region "sobj.rendererOptions.fill"
				If sobj.rendererOptions.fill = False Then
					sb.Append("fill: ").Append(sobj.rendererOptions.fill).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region "sobj.rendererOptions.lineWidth"
				If sobj.rendererOptions.lineWidth <> -1 Then
					sb.Append("lineWidth: ").Append(sobj.rendererOptions.lineWidth).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region "sobj.rendererOptions.bubbleGradients"
				If sobj.rendererOptions.bubbleGradients = True Then
					sb.Append("bubbleGradients: true,")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region

#Region "sobj.rendererOptions.bubbleAlpha"
				If sobj.rendererOptions.bubbleAlpha <> -1 Then
					sb.Append("bubbleAlpha: ").Append(sobj.rendererOptions.bubbleAlpha).Append(",")
					sSize = sSize + 1
					ro = ro + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
#End Region
			sb.Append("},").append(CRLF)
			sobj.rendererOptions.size = ro
			sobj.size = sSize
			Return sb.tostring
#End Region
End Sub


'Sub to render an series properties: defaults, each series
private Sub RenderSeries(sobj As seriesObject, bIncludeLB As Boolean) As String
		Dim sSize As Int = 0
		Dim sb As StringBuilder
		sb.Initialize
     	sb.Append("{")
		If bIncludeLB = True Then sb.Append(CRLF)
#Region "SeriesDefaults.Renderer"
			If sobj.Renderer.Length > 0 Then
				sb.Append("renderer: ").Append(sobj.renderer).Append(",")
				sSize = sSize + 1
				If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region
#Region "second x axis"
			If sobj.xAxis.Length > 0 Then
				sb.Append("xaxis: '").Append(sobj.xAxis).Append("',")
				sSize = sSize + 1
				If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region

#Region "second axes"
			If sobj.yAxis.Length > 0 Then
				sb.Append("yaxis: '").Append(sobj.yAxis).Append("',")
				sSize = sSize + 1
				If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region

#Region series.Label
		If sobj.label.Length > 0 Then
			sb.Append("label: '").Append(sobj.label).Append("',")
			sSize = sSize + 1
			If bIncludeLB = True Then sb.Append(CRLF)
		End If
#End Region

#Region series.linePattern
			If sobj.linePattern.Length > 0 Then
				sb.Append("linePattern: '").Append(sobj.linePattern).Append("',")
				sSize = sSize + 1
				If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region
#Region series.lineWidth
			If sobj.lineWidth > 0 Then
				sb.Append("lineWidth: ").Append(sobj.LineWidth).Append(",")
				sSize = sSize + 1
				If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region
#Region series.trendLine
			sb.Append(CRLF)
			If (sobj.trendline.Show = True) Or (sobj.trendline.color.Length) > 0 Or (sobj.trendline.typeof.Length > 0) Then
			sb.Append("trendline:{")
				If sobj.trendline.Show = True Then
					sb.Append("show: true,")
					sSize = sSize + 1
				End If
				If sobj.trendline.color.Length > 0 Then
					sb.Append("color: '").Append(sobj.trendline.Color).Append("',")
					sSize = sSize + 1
				End If
				If sobj.trendline.typeof.Length > 0 Then
					sb.Append("type:'").Append(sobj.trendline.typeof).Append("',")
					sSize = sSize + 1
				End If
				If sobj.trendline.lineWidth.Length > 0 Then
					sb.Append("lineWidth:").Append(sobj.trendline.lineWidth)
					sSize = sSize + 1
				End If
			sb.Append("},")
			If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region
	

#Region "series.fill"
			If sobj.fill = True Then
				sb.Append("fill: true,")
				sSize = sSize + 1
				If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region
#Region series.neighborThreshold
			If sobj.neighborThreshold.Length > 0 Then
				sb.Append("neighborThreshold: ").Append(sobj.neighborThreshold).Append(",")
				sSize = sSize + 1
				If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region
		
#Region "sobj.fillAndStroke"
			If sobj.fillAndStroke = True Then
				sb.Append("fillAndStroke: true,")
				sSize = sSize + 1
				If bIncludeLB = True Then sb.Append(CRLF)
			End If
			sb.Append(CRLF)
#End Region
#Region "sobj.rendererOptions"
			Dim ros As String
			ros = RenderOptions(sobj,bIncludeLB)
			If sobj.rendererOptions.size > 0 Then
				sb.Append(ros)
			End If
#End Region
#Region "sobj.pointLabels"
			If (sobj.pointLabels.Show = True) Or (sobj.pointLabels.Location.Length > 0) Or (sobj.pointLabels.edgeTolerance.Length > 0) Then
			sb.Append("pointLabels:{")
			If bIncludeLB = True Then sb.Append(CRLF)
				If sobj.pointLabels.show = True Then
					sb.Append("show: true,")
					sSize = sSize + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
				If sobj.pointLabels.Location.Length > 0 Then
					sb.Append("location: '").Append(sobj.pointLabels.location).Append("',")
				    sSize = sSize + 1
					If bIncludeLB = True Then sb.Append(CRLF)
				End If
				If sobj.pointLabels.edgeTolerance.Length > 0 Then
					sb.Append("edgeTolerance: ").Append(sobj.pointLabels.edgeTolerance).Append(",")
					sSize = sSize + 1
				    If bIncludeLB = True Then sb.Append(CRLF)
				End If
			sb.Append("},")
			If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region

#Region "sobj.showMarker"			
			If sobj.showMarker = False Then
				sb.Append("showMarker: false,")
				sSize = sSize + 1
				If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region

#Region "sobj.showLine"
			If sobj.showLine = False Then
				sb.Append("showLine: false,")
				sSize = sSize + 1
				If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region			

#Region "sobj.markerOptions"
			If (sobj.markerOptions.show = False) Or (sobj.markerOptions.style.Length > 0) Or (sobj.markerOptions.size > 0) Then
			sb.Append("markerOptions: {")
			If sobj.markerOptions.show = False Then
				sb.Append("show: false,")
				sSize = sSize + 1
			End If
			If sobj.markerOptions.style.length > 0 Then
				sb.Append("style: '").Append(sobj.markerOptions.style).Append("'").Append(",")
				sSize = sSize + 1
			End If
			If sobj.markerOptions.size > 0 Then
				sb.Append("size : ").Append(sobj.markerOptions.size).Append(",")
				sSize = sSize + 1
			End If
		sb.Append("},")
		If bIncludeLB = True Then sb.Append(CRLF)
		End If
#End Region

#Region "sobj.shadow"
			If sobj.shadow = False Then
				sb.Append("shadow: false,")
				sSize = sSize + 1
				If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region

#Region "sobj.step"
			If sobj.bstep = True Then
				sb.Append("step: true,")
				sSize = sSize + 1
				If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region

#Region "sobj.showAngle"
			If sobj.showHighlight = False Then
				sb.Append("showHighlight: ").Append(sobj.showHighlight).Append(",")
				sSize = sSize + 1
				If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region

#Region "sobj.showHighlight"
			If sobj.showAngle.length > 0 Then
				sb.Append("showAngle: ").Append(sobj.showAngle).Append(",")
				sSize = sSize + 1
				If bIncludeLB = True Then sb.Append(CRLF)
			End If
#End Region

		sb.Append("}")
		sobj.size = sSize
		Return sb.tostring
#End Region
End Sub

'sub to render an axis
private Sub RenderAxis(axis As AxisObject) As String
	Dim sSize As Int = 0
	Dim sb As StringBuilder
	sb.Initialize
	#Region "Axis"
			sb.Append(axis.axisname).Append(":{").Append(CRLF)
#Region "Axis.MinMax"
				If axis.sMin.length > 0 Then
					sb.Append("min: ").Append(axis.sMin).Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
				If axis.sMax.Length > 0 Then
					sb.Append("max: ").Append(axis.sMax).Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region
#Region "axis.Renderer"
				If axis.Renderer.Length > 0 Then
					sb.Append("renderer: ").Append(axis.renderer).Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region
#Region "axis.tickInterval"
				If axis.tickInterval.Length > 0 Then
					sb.Append("tickInterval: ").Append(axis.tickInterval).Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region

#Region axis.useSeriesColor
				If axis.useSeriesColor = True Then
					sb.Append("useSeriesColor: true,").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region
				If axis.autoscale = True Then
					sb.Append("autoscale: true,").Append(CRLF)
					sSize = sSize + 1
				End If

#Region "axis.drawMajorGridlines"
				If axis.drawMajorGridlines = False Then
					sb.Append("drawMajorGridlines: ").Append(axis.drawMajorGridlines).Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region
#Region "axis.drawMinorGridlines"
				If axis.drawMinorGridlines = False Then
					sb.Append("drawMinorGridlines: ").Append(axis.drawMinorGridlines).Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region
#Region "axis.drawMajorTickMarks"
				If axis.drawMajorTickMarks = False Then
					sb.Append("drawMajorTickMarks: ").Append(axis.drawMajorTickMarks).Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region

#Region "axis.rendererOptions"
			If (axis.rendererOptions.tickInset.Length > 0) Or (axis.rendererOptions.minorTicks.Length > 0) Or (axis.rendererOptions.forceTickAt0 = True Or axis.rendererOptions.alignTicks = True) Then
			sb.Append("rendererOptions:{").Append(CRLF)
#Region "axis.renderOptions.tickInset"
				If axis.rendererOptions.tickInset.Length > 0 Then
					sb.Append("tickInset: ").Append(axis.rendererOptions.tickInset)
					sb.Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region
				If axis.rendererOptions.alignTicks = True Then
					sb.Append("alignTicks: true,").Append(CRLF)
					sSize = sSize + 1
				End If
#Region "axis.renderOptions.minorTicks"
				If axis.rendererOptions.minorTicks.Length > 0 Then
					sb.Append("minorTicks: ").Append(axis.rendererOptions.minorTicks)
					sb.Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region
#Region "axis.renderOptions.forceTickAt0"
				If axis.rendererOptions.forceTickAt0 = True Then
					sb.Append("forceTickAt0: ").Append(axis.rendererOptions.forceTickAt0)
					sb.Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region
			sb.Append("},").Append(CRLF)
			End If
#End Region

#Region "axis.tickRenderer"
				If axis.tickRenderer.Length > 0 Then
					sb.Append("tickRenderer: ").Append(axis.tickRenderer)
					sb.Append(",").Append(CRLF)
					sSize = sSize + 1
				End If	
#End Region	
#Region "axis.tickOptions"
				If (axis.tickOptions.formatString.Length > 0) Or (axis.tickOptions.fontSize.Length > 0) Or _
				(axis.tickOptions.angle <> 361) Or (axis.tickOptions.formatter.Length > 0) Or (axis.tickOptions.showGridline = False) Then			
				sb.Append("tickOptions:{").append(CRLF)
					If axis.tickOptions.formatString.Length > 0 Then
						sb.Append("formatString: '").Append(axis.tickOptions.formatString).Append("'")
						sb.Append(",").Append(CRLF)
						sSize = sSize + 1
					End If
					If axis.tickOptions.fontSize.Length > 0 Then
						sb.Append("fontSize: '").Append(axis.tickOptions.fontSize)
						sb.Append("',").Append(CRLF)
						sSize = sSize + 1
					End If
					If axis.tickOptions.angle <> 361 Then
						sb.Append("angle: ").Append(axis.tickOptions.angle)
						sb.Append(",").Append(CRLF)
						sSize = sSize + 1
					End If
					If axis.tickOptions.formatter.Length > 0 Then
						sb.Append("formatter: ").Append(axis.tickOptions.formatter)
						sb.Append(",").Append(CRLF)
						sSize = sSize + 1
					End If
					If axis.tickOptions.showGridline = False Then
						sb.Append("showGridline: false,").Append(CRLF)
						sSize = sSize + 1
					End If		
				sb.Append("}").Append(",").Append(CRLF)
				End If
#End Region
#Region "axis.label
				If axis.label.Length > 0 Then
					sb.Append("label: ").Append(QUOTE).Append(axis.label).Append(QUOTE)
					sb.Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region
#Region "axis.labelRenderer"
				If axis.labelRenderer.Length > 0 Then
					sb.Append("labelRenderer: ").Append(axis.labelRenderer).Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region

#Region "axis.pad"
				If axis.pad.Length > 0 Then
					sb.Append("pad: ").Append(axis.pad).Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region
#Region "axis.numberticks
				If axis.numberticks > 0 Then
					sb.Append("numberTicks: ").Append(axis.numberTicks).Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region
#Region "axis.ticks"				
				If (axis.ticks.Size -1) <> -1 Then
					sb.Append("ticks: ").Append(axis.ticksName).Append(",").Append(CRLF)
					sSize = sSize + 1
				End If
#End Region
			sb.Append("},").Append(CRLF)
			axis.size = sSize
			Return sb.tostring
#End Region
End Sub