﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private iX As String
	Private iY As String
	Public li As HTMLElement
	Public ID As String
	Private SubWay As MashSubway
	Private lineP As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(sb As MashSubway,linePos As Int, X As String, Y As String) As MashSubwayItem
	iX = X
	iY = y
	SubWay = sb
	lineP = linePos
	ID = ""
	'generate a markerID
	Dim li As HTMLElement
	li.Initialize("item","li")
	li.AddProperty("data-coords",$"${x},${y}"$)
	Return Me
End Sub

'this should be the last call
Sub AddIt
	SubWay.AddItem(lineP,Me)
End Sub

Public Sub AtStation As MashSubwayItem
	li.AddProperty("data-marker","@station")
	Return Me
End Sub


Public Sub Station As MashSubwayItem
	li.AddProperty("data-marker","station")
	Return Me
End Sub

public Sub South As MashSubwayItem
	li.AddProperty("data-dir", "S")
	Return Me
End Sub

public Sub West As MashSubwayItem
	li.AddProperty("data-dir", "W")
	Return Me
End Sub

public Sub North As MashSubwayItem
	li.AddProperty("data-dir", "N")
	Return Me
End Sub

public Sub East As MashSubwayItem
	li.AddProperty("data-dir", "E")
	Return Me
End Sub

public Sub DottedLine As MashSubwayItem
	li.AddProperty("data-dotted-line","true")
	Return Me
End Sub

Public Sub Interchange As MashSubwayItem
	li.AddProperty("data-marker","interchange")
	Return Me
End Sub

Public Sub AtInterchange As MashSubwayItem
	li.AddProperty("data-marker","@interchange")
	Return Me
End Sub

Public Sub V1 As MashSubwayItem
	li.AddProperty("data-markerInfo","v1")
	Return Me
End Sub

Public Sub V2 As MashSubwayItem
	li.AddProperty("data-markerInfo","v2")
	Return Me
End Sub

Public Sub V3 As MashSubwayItem
	li.AddProperty("data-markerInfo","v2")
	Return Me
End Sub

Public Sub V4 As MashSubwayItem
	li.AddProperty("data-markerInfo","v3")
	Return Me
End Sub

Public Sub V5 As MashSubwayItem
	li.AddProperty("data-markerInfo","v5")
	Return Me
End Sub

Public Sub H5 As MashSubwayItem
	li.AddProperty("data-markerInfo","h5")
	Return Me
End Sub

Public Sub H4 As MashSubwayItem
	li.AddProperty("data-markerInfo","h4")
	Return Me
End Sub

Public Sub H3 As MashSubwayItem
	li.AddProperty("data-markerInfo","h3")
	Return Me
End Sub

Public Sub H2 As MashSubwayItem
	li.AddProperty("data-markerInfo","h2")
	Return Me
End Sub

Public Sub H1 As MashSubwayItem
	li.AddProperty("data-markerInfo","h1")
	Return Me
End Sub

Sub LabelAtN As MashSubwayItem
	li.AddProperty("data-labelPos","N")
	Return Me
End Sub

Sub LabelAtNE As MashSubwayItem
	li.AddProperty("data-labelPos","NE")
	Return Me
End Sub

Sub LabelAtNW As MashSubwayItem
	li.AddProperty("data-labelPos","NW")
	Return Me
End Sub

Sub LabelAtS As MashSubwayItem
	li.AddProperty("data-labelPos","S")
	Return Me
End Sub

Sub LabelAtSE As MashSubwayItem
	li.AddProperty("data-labelPos","SE")
	Return Me
End Sub

Sub LabelAtSW As MashSubwayItem
	li.AddProperty("data-labelPos","SW")
	Return Me
End Sub

Sub LabelAtE As MashSubwayItem
	li.AddProperty("data-labelPos","E")
	Return Me
End Sub

Sub LabelAtW As MashSubwayItem
	li.AddProperty("data-labelPos","W")
	Return Me
End Sub

Sub Text(Caption As String) As MashSubwayItem
	If SubWay.HideLabels = False Then
		li.AddContent(Caption)
	End If
	Return Me
End Sub

Sub HyperLink1(href As String, caption As String) As MashSubwayItem
	HyperLink(caption,href)
	Return Me
End Sub

Sub HyperLink(Caption As String, href As String) As MashSubwayItem
	If SubWay.HideLabels = True Then Caption = ""
	Dim a As HTMLElement
	a.Initialize($"a${iX}${iY}"$,"a")
	'a.AddClass("stext")
	'a.AddStyleAttribute("width","100px")
	'a.AddStyleAttribute("text-align","center")
	'a.AddStyleAttribute("margin","12px 0 0 -50px")
	'a.AddProperty("title","")
	'a.AddStyleAttribute("position","absolute")
	'a.AddStyleAttribute("z-index","3000")
	a.SetHREF(href)
	If Caption <> "" Then 
		a.AddContent(Caption)
		'a.AddAttribute("title",Caption,True)
	End If
	li.AddContent(a.HTML.Replace(CRLF,""))
	Return Me
End Sub