﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ID As String
	Public Element As HTMLElement
	Public Theme As String
	Public Enabled As Boolean
	Public TextVisible As Boolean
	Public Text As String
	Public HREF As String
	Public Visibility As String
	Public WavesEffect As Boolean
	Public WavesType As String
	Public WavesCircle As Boolean
	Public ZDepth As String
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(sID As String)
	ID = sID.tolowercase
	HREF = "#!"
	Text = ""
	Visibility = ""
	Enabled = True
	TextVisible = True
	Theme = ""
	ZDepth = ""
	Element.Initialize(ID,"a")
	WavesType = ""
	WavesCircle = False
	WavesEffect = True
End Sub

Sub AddContent(sText As String)
	Element.AddContent(sText)
End Sub

Sub HTML As String
	'define the anchor
	Element.ID = ID
	Element.SetHRef(HREF)
	MashPlugIns.MaterialUseTheme(Theme,Element)
	Element.MaterialEnable(Enabled)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialVisibility(Visibility)
	Element.MaterialWavesEffect(WavesEffect)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle)
	If TextVisible = True Then Element.AddContent(Text)
	Return Element.html
End Sub