﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Private compID As String
	Public Visibility As String
	Public Enabled As Boolean
	Private Element As HTMLElement
	Private ABM As ABMaterial
	Private JavaCalls As List
End Sub

Public Sub Initialize(InternalPage As ABMPage, ID As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	JavaCalls.initialize
	Page = InternalPage
	compID = ID.tolowercase
	Element = Element.Initialize(compID,"div")
	Visibility = ""
	Enabled = True
End Sub

private Sub BuildOptions As String
	Dim options As String = $"$('form').card({
    // a selector or DOM element for the container
    // where you want the card to appear
    container: '.card-wrapper', // *required*
	formatting: true,
});"$
Return options
End Sub

Sub HTML As String
	Dim xContent As String = $"<div id="${compID}" z-depth-2 style="width:100%;max-width:350px;margin: 50px auto;">
        <div class="card-wrapper jp-card-dinersclub"></div>
        <div class="form-container active">
            <form action="">
                <input placeholder="•••• •••• •••• ••••" type="tel" name="number" class="form-control">
                <input placeholder="Full name" type="text" name="name" class="form-control">
                <input placeholder="••/••••" type="tel" name="expiry" class="form-control">
                <input placeholder="•••" type="tel" name="cvc" class="form-control">
            </form>
        </div>
    </div>"$
	JavaCalls.Add("Materialize.updateTextFields();")
	JavaCalls.Add(BuildOptions)
	Return xContent
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,compID,HTML)
	'JavaCalls.Add($"$('#${compID}').jGallery(${BuildOptions});"$)
	Dim script As String = MashPlugIns.MvFromList(JavaCalls,"")
	Page.ws.Eval(script, Array As String(compID))
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub