﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Public Element As HTMLElement
	Public ZDepth As String
	Public Visibility As String
	Public Enabled As Boolean
	Public Title As String
	Private page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Public ToolTip As String
	Private ABM As ABMaterial
	Public Speed As String
	Public SpeedVariation As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	Element.Initialize(compID,"div")
	page = InternalPage
	JavaCalls.Initialize
	compID = ID.tolowercase
	Enabled = True
	ZDepth = ""
	Visibility = ""
	Title = ""
	Element.Initialize(compID,"div")
	Speed = "3"
	SpeedVariation = "2"
End Sub

Sub HTML As String
	
	Element.MaterialVisibility(Visibility).MaterialZdepth(ZDepth).MaterialEnable(Enabled)
	Element.AddClass("splitflap")
Dim soptions As String = $"$('#${compID}').splitFlap({
image:'../images/chars.png',
imageSize:'',
charsMap:'ABCDEFGHIJKLMNOPQRSTUVWXYZ 0123456789.,!?#@()+-=',
charWidth:50,
charHeight:100,
charSubstitute:' ',
speed:${Speed},
speedVariation:${SpeedVariation},
text:'${Title}',
textInit:'',
autoplay:true,
onComplete:function(){}
});"$
	JavaCalls.Add(soptions)
	Return Element.html
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(page,compID,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	page.ws.Eval(script, Array As String(compID))
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	page = InternalPage
	compID = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub