﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
Sub Class_Globals
	Dim ABM As ABMaterial
	Dim ABMComp As ABMCustomComponent
	Public Height As String
	Public Width As String
	Public HTML As String
	Private iID As String
	Private Tasks As Map
	Private Resources As Map
	Public scheduleStartDate As String
	Public scheduleEndDate As String
	Public ShowToolBar As Boolean
	Type TaskType(taskID As String, pId As String, taskName As String, startDate As String, endDate As String, duration As String, progress As String, predecessor As String, resourceId As String, baselineStartDate As String,baselineEndDate As String)
	Public Task As TaskType
	Type ResourceType(Id As String, Name As String, EmailAddress As String)
	Private TaskResourceMap As Map
	Public allowSorting As Boolean
	Public allowMultiSorting As Boolean
	Public highlightWeekEnds As Boolean
	Public allowGanttChartEditing As Boolean
	Public enableContextMenu As Boolean
	Public showColumnChooser As Boolean
	Public enableVirtualization As Boolean
	Public includeWeekend As Boolean
	Type EditModeEnum(cellEditing As String, normal As String)
	Public EnumEditMode As EditModeEnum
	Public EditMode As String
	Public enableProgressBarResizing As Boolean
	Public allowColumnResize As Boolean
	Public showColumnOptions As Boolean
	Public allowDragAndDrop As Boolean
	Public enableAltRow As Boolean
	Public RowHeight As Int
	Public ShowTaskLabels As Boolean
	Dim allowSelection As Boolean
	Type SelectionModeEnum(row As String, cell As String)
	Public EnumSelectionMode As SelectionModeEnum
	Public SelectionMode As String
	Type SelectionTypeEnum(single As String, multiple As String)
	Public EnumSelectionType As SelectionTypeEnum
	Public SelectionType As String
	Public RenderBaseLine As Boolean
	Public showResourceNames As Boolean
	Public enableTaskbarTooltip As Boolean
	Public enableTaskbarDragTooltip As Boolean
	Public showGridCellTooltip As Boolean
	Public showExpandGridCellTooltip As Boolean
	Public HideHolidays As Boolean
	'new properties
	Public allowKeyboardNavigation As Boolean
	Public allowMultipleExporting As Boolean
	Public enablePredecessorValidation As Boolean
	Public baseLineColor As String
	Public dateFormat As String
	Public isResponsive As Boolean
	Public splitterIndex As String
	Public enableWBS As Boolean
	Public enableWBSPredecessor As Boolean
	Private Holidays As Map
	Private Events As Map
	Type EventType(day As String, label As String, lineStyle As String, lineColor As String, lineWidth As String, background As String)
	Type TaskTypes(FixedUnit As String, FixedWork As String, FixedDuration As String)
	Public EnumTaskTypes As TaskTypes
	Public ProjectTasksType As String
	Type WorkUnitType(Day As String, Hour As String, Minute As String)
	Public EnumWorkUnit As WorkUnitType
	Public WorkUnit As String
	Type taskSchedulingModeType(Auto As String, Manual As String, Custom As String)
	Public EnumtaskSchedulingMode As taskSchedulingModeType
	Public taskSchedulingMode As String
	Private Notes As Map
	Public showTaskNames As Boolean
	Public ReadOnly As Boolean
	Public treeColumnIndex As Int
	Type workingTimeScaleEnum(TimeScale8Hours As String, TimeScale24Hours As String)
	Public EnumworkingTimeScale As workingTimeScaleEnum
	Public workingTimeScale As String
	Public ShowToolBar As Boolean
	Public allowEditing As Boolean
	Public allowIndent As Boolean
	Public allowOutdent As Boolean
	Public allowAdding As Boolean
	Public allowDeleting As Boolean
	Type TimeScaleEnum(weekMode As String, monthMode As String, yearMode As String, dayMode As String, hourMode As String)
	Public EnumTimeScale As TimeScaleEnum
	Public TimeScale As String
	Public showProgressStatus As Boolean
	Public HideNotes As Boolean
	Public HideProgress As Boolean
	Public HidePredecessor As Boolean
	Public ShowTaskMode As Boolean
	Public ShowWork As Boolean
	Public ShowEffort As Boolean
	Public ShowTaskType As Boolean
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String)
	EnumTimeScale.Initialize
	EnumTimeScale.dayMode = "daymode"
	EnumTimeScale.hourMode = "hourmode"
	EnumTimeScale.monthMode = "monthmode"
	EnumTimeScale.weekMode = "weekmode"
	EnumTimeScale.yearMode = "yearmode"
	EnumworkingTimeScale.Initialize
	EnumworkingTimeScale.TimeScale24Hours = "ej.Gantt.workingTimeScale.TimeScale24Hours"
	EnumworkingTimeScale.TimeScale8Hours = "ej.Gantt.workingTimeScale.TimeScale24Hours"
	workingTimeScale = EnumworkingTimeScale.TimeScale8Hours
	EnumTaskTypes.Initialize
	EnumTaskTypes.FixedDuration = "ej.Gantt.TaskType.FixedDuration"
	EnumTaskTypes.FixedUnit = "ej.Gantt.TaskType.FixedUnit"
	EnumTaskTypes.FixedWork = "ej.Gantt.TaskType.FixedWork"
	EnumWorkUnit.Initialize
	EnumWorkUnit.Day = "ej.Gantt.WorkUnit.Day"
	EnumWorkUnit.Hour = "ej.Gantt.WorkUnit.Hour"
	EnumWorkUnit.Minute = "ej.Gantt.WorkUnit.Minute"
	EnumtaskSchedulingMode.Initialize
	EnumtaskSchedulingMode.Auto = "ej.Gantt.TaskSchedulingMode.Auto"
	EnumtaskSchedulingMode.Custom = "ej.Gantt.TaskSchedulingMode.Custom"
	EnumtaskSchedulingMode.Manual = "ej.Gantt.TaskSchedulingMode.Manual"
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	Tasks.Initialize
	Resources.Initialize
	Width = "100%"
	Height = "100%"
	HTML = ""
	TaskResourceMap.Initialize
	allowGanttChartEditing = True
	HideHolidays = False
	highlightWeekEnds = True
	includeWeekend = True
	ShowToolBar = True
	enableContextMenu = False
	showColumnChooser = False
	enableVirtualization = False
	EditMode = "normal"
	EnumEditMode.Initialize
	EnumEditMode.cellEditing = "cellEditing"
	EnumEditMode.normal = "normal"
	enableProgressBarResizing = True
	allowColumnResize = True
	showColumnOptions = False
	allowDragAndDrop = True
	HideProgress = False
	enableAltRow = False
	RowHeight = 0
	ShowTaskLabels = False
	allowSelection = False
	HidePredecessor = False
	EnumSelectionMode.Initialize
	EnumSelectionMode.cell = "cell"
	EnumSelectionMode.row = "row"
	SelectionMode = EnumSelectionMode.row
	EnumSelectionType.Initialize
	EnumSelectionType.multiple = "multiple"
	EnumSelectionType.single = "single"
	SelectionType = EnumSelectionType.single
	RenderBaseLine = False
	showResourceNames = False
	enableTaskbarTooltip = True
	enableTaskbarDragTooltip = False
	showGridCellTooltip = False
	showExpandGridCellTooltip = True
	allowKeyboardNavigation = True
	allowMultipleExporting = False
	enablePredecessorValidation = False
	ShowTaskMode = False
	showTaskNames = True
	splitterIndex = 5
	enableWBS = False
	dateFormat = "dd/MM/yyyy"
	isResponsive = True
	enableWBSPredecessor = False
	ProjectTasksType = ""
	baseLineColor = "blue"
	WorkUnit = EnumWorkUnit.Day
	ProjectTasksType = EnumTaskTypes.FixedWork
	taskSchedulingMode = EnumtaskSchedulingMode.Auto
	Holidays.Initialize
	Events.Initialize
	Notes.Initialize
	ReadOnly = False
	treeColumnIndex = 0
	allowEditing = True
	allowIndent = True
	allowOutdent = True
	allowAdding = True
	allowDeleting = True
	showProgressStatus = True
	HideNotes = True
	ShowWork = True
	ShowEffort = True
	ShowTaskType = True
End Sub
'set the overall project task type
Sub SetProjectTasksType(sTaskType As String)
	ProjectTasksType = sTaskType
End Sub
'initialize an avent
Sub InitializeEvent(event As EventType) As EventType
	event.Initialize
	event.background =""
	event.day = ""
	event.label = ""
	event.lineColor = "darkblue"
	event.lineStyle = "dotted"
	event.lineWidth = 2
	Return event
End Sub
'add a task to the gantt chart
Sub AddTask(pId As String, taskID As String, taskName As String, startDate As String, endDate As String, duration As String, progress As String, predecessor As String, baselineStartDate As String,baselineEndDate As String)
	'create a new task
	Dim tsk As TaskType
	' initialize the task
	tsk = InitializeTask(tsk)
	'assign the properties
	tsk.taskID = taskID
	tsk.pId = pId
	tsk.duration = duration
	tsk.endDate = endDate
	tsk.progress = progress
	tsk.resourceId = ""
	tsk.startDate = startDate
	tsk.taskName = taskName
	tsk.baselineStartDate = baselineStartDate
	tsk.baselineEndDate = baselineEndDate
	tsk.predecessor = predecessor
	'define the map key
	Dim tskKey As String = "tsk_" & taskID
	'add the task to the tasks collection map
	Tasks.Put(tskKey,tsk)
End Sub
'add a resource to the plan, a resource can/cannot be used
Sub AddResource(Name As String, EmailAddress As String) As ResourceType
	Dim res As ResourceType
	Dim resid As Int
	res = InitializeResource(res)
	res.Name = Name
	res.EmailAddress = EmailAddress
	'use the name to add resources to the, these should be unique
	Dim resKey As String = Name.tolowercase
	'if the resource already exists
	If Resources.ContainsKey(resKey) = False Then
		' how many resources we have on the table now
		resid = Resources.Size
	Else
		resid = MapGetKeyPos(resKey,Resources)
	End If
	res.Id = resid
	'update the resources map
	Resources.put(resKey, res)
	' return the resource
	Return res
End Sub
'add a resource to the plan, a resource can/cannot be used
Sub AddResource1(resID As String, Name As String, EmailAddress As String) As ResourceType
	Dim res As ResourceType
	res = InitializeResource(res)
	res.Name = Name
	res.EmailAddress = EmailAddress
	res.Id = resID
	Dim resKey As String = Name.tolowercase
	Resources.put(resKey, res)
	Return res
End Sub
'return the position of a map key
private Sub MapGetKeyPos(strKey As String, mp As Map) As Int
	Dim kcnt As Int
	Dim ktot As Int = mp.Size - 1
	Dim kstr As String
	For kcnt = 0 To ktot
		kstr = mp.GetKeyAt(kcnt)
		If kstr.ToLowerCase = strKey.ToLowerCase Then
			Return kcnt
		End If
	Next
	Return -1
End Sub
' convert a json string to a list
private Sub Json2List(strValue As String) As List
	Dim parser As JSONParser
	parser.Initialize(strValue)
	Return parser.NextArray
End Sub
'convert a list to a json string
private Sub List2JSON(lst As List) As String
	Dim sOut As String
	Dim jsonGen As JSONGenerator
	jsonGen.Initialize2(lst)
	sOut = jsonGen.ToString
	Return sOut
End Sub
'add a resource to a task
Sub AddTaskResource(taskID As String, Name As String) As Boolean
	'define the task key
	Dim tskKey As String = "tsk_" & taskID
	'find the task from existing tasks
	Dim tskPos As Int = MapGetKeyPos(tskKey, Tasks)
	' the task was not found
	If tskPos = -1 Then Return False
	'we find the resource from the resources map
	Dim resKey As String = Name.tolowercase
	Dim rsPos As Int = MapGetKeyPos(resKey, Resources)
	' a resource should already exist in the resource map
	If rsPos = -1 Then Return False
	' now establish the link between the task and the resource
	Dim existingJSON As String = TaskResourceMap.GetDefault(tskKey,"")
	Dim existingList As List
	If existingJSON.Length > 0 Then
		existingList = Json2List(existingJSON)
	Else
		existingList.Initialize
	End If
	'does the resource already exist (use the resource id)
	If existingList.IndexOf(rsPos) = -1 Then existingList.Add(rsPos)
	'save back the json
	existingJSON = List2JSON(existingList)
	TaskResourceMap.Put(tskKey,existingJSON)
	Return True
End Sub
'add a resource to a task
Sub AddTaskResource1(taskID As String, rsPos As String) As Boolean
	'define the task key
	Dim tskKey As String = "tsk_" & taskID
	'find the task from existing tasks
	Dim tskPos As Int = MapGetKeyPos(tskKey, Tasks)
	' the task was not found
	If tskPos = -1 Then Return False
	' now establish the link between the task and the resource
	Dim existingJSON As String = TaskResourceMap.GetDefault(tskKey,"")
	Dim existingList As List
	If existingJSON.Length > 0 Then
		existingList = Json2List(existingJSON)
	Else
		existingList.Initialize
	End If
	'does the resource already exist (use the resource id)
	If existingList.IndexOf(rsPos) = -1 Then existingList.Add(rsPos)
	'save back the json
	existingJSON = List2JSON(existingList)
	TaskResourceMap.Put(tskKey,existingJSON)
	Return True
End Sub
'add a note to a task
Sub AddTaskNote(taskID As String, Note As String) As Boolean
	'define the task key
	Dim tskKey As String = "tsk_" & taskID
	'find the task from existing tasks
	Dim tskPos As Int = MapGetKeyPos(tskKey, Tasks)
	' the task was not found
	If tskPos = -1 Then Return False
	' now add the task baseline
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("notes: ").Append(Note)
	Notes.Put(tskKey, sb.ToString)
	Return True
End Sub
'build the resource ids linked to this task
Private Sub BuildTaskResources(taskID As String) As String
	'define the task key
	Dim tskKey As String = "tsk_" & taskID
	'does resources for this task exist in the task resource map
	Dim resPos As Int = MapGetKeyPos(tskKey, TaskResourceMap)
	'return a blank resource array
	If resPos = -1 Then
		Return "[]"
	End If
	'lets build the resource list
	Dim existingJSON As String = TaskResourceMap.GetDefault(tskKey,"")
	Dim existingList As List = Json2List(existingJSON)
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[")
	sb.Append(List2DelimString(existingList,","))
	sb.Append("]")
	Return sb.tostring
End Sub
'convert a list to a delimited string
Private Sub List2DelimString(lst As List, delim As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	For Each strItem As String In lst
		sb.Append(strItem).append(delim)
	Next
	If sb.ToString.EndsWith(delim) = True Then sb.Remove(sb.Length-1,sb.Length)
	Return sb.tostring
End Sub
'initialize a resource for the project
private Sub InitializeResource(rsc As ResourceType) As ResourceType
	rsc.Initialize
	rsc.Name = ""
	rsc.EmailAddress = ""
	Return rsc
End Sub
'initialize a blank task for entry
private Sub InitializeTask(tsk As TaskType) As TaskType
	tsk.Initialize
	tsk.taskID = -1
	tsk.pId = ""
	tsk.duration = ""
	tsk.endDate = ""
	tsk.progress = ""
	tsk.resourceId = ""
	tsk.startDate = ""
	tsk.taskName = ""
	tsk.predecessor = ""
	tsk.progress = ""
	tsk.predecessor = ""
	tsk.baselineStartDate = ""
	tsk.baselineEndDate = ""
	Return tsk
End Sub
' return a quoted string
private Sub InQuotes(sValue As String) As String
	Return QUOTE & sValue & QUOTE
End Sub
'build the resource data map
private Sub BuildResources() As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[")
	For Each resKey As String In Resources.Keys
		Dim res As ResourceType = Resources.Get(resKey)
		Dim resid As String = res.Id
		Dim resName As String = res.Name
		sb.Append("{")
		sb.Append("resourceId: ").Append(resid).Append(",")
		sb.Append("resourceName: ").Append(InQuotes(resName))
		sb.Append("},")
	Next
	If sb.ToString.EndsWith(",") = True Then sb.Remove(sb.Length-1,sb.Length)
	sb.Append("]")
	Return sb.tostring
End Sub
'build the events on this project
private Sub BuildEvents() As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[")
	For Each eventKey As String In Events.Keys
		Dim event As String = Events.Get(eventKey)
		sb.Append(event).Append(",")
	Next
	If sb.ToString.EndsWith(",") = True Then sb.Remove(sb.Length-1,sb.Length)
	sb.Append("]")
	Return sb.tostring
End Sub
'build the holidays on this project
private Sub BuildHolidays() As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[")
	For Each eventKey As String In Holidays.Keys
		Dim event As String = Holidays.Get(eventKey)
		sb.Append(event).Append(",")
	Next
	If sb.ToString.EndsWith(",") = True Then sb.Remove(sb.Length-1,sb.Length)
	sb.Append("]")
	Return sb.tostring
End Sub
'build the tasks
private Sub BuildTasks() As String
	Dim tskItem As StringBuilder
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[")
	For Each strTask As String In Tasks.Keys
		Dim tsk As TaskType = Tasks.Get(strTask)
		tskItem.Initialize
		tskItem.Append(BuildTask(tsk)).Append(",")
		sb.Append(tskItem.ToString)
	Next
	If sb.ToString.EndsWith(",") = True Then sb.Remove(sb.Length-1,sb.Length)
	sb.Append("]")
	Return sb.tostring
End Sub
'build the task string
private Sub BuildTask(tsk As TaskType) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{taskID: ").Append(tsk.taskID).Append(",")
	If tsk.pId.Length > 0 Then sb.Append("pId: ").Append(tsk.pId).Append(",")
	If tsk.taskName.Length > 0 Then sb.Append("taskName: ").Append(InQuotes(tsk.taskName)).Append(",")
	If tsk.startDate.Length > 0 Then sb.Append("startDate: ").Append(InQuotes(tsk.startDate)).Append(",")
	If tsk.endDate.Length > 0 Then sb.Append("endDate: ").Append(InQuotes(tsk.endDate)).Append(",")
	If tsk.duration.Length > 0 Then 	sb.Append("duration: ").Append(tsk.duration).Append(",")
	If tsk.progress.Length > 0 Then 	sb.Append("progress: ").Append(InQuotes(tsk.progress)).Append(",")
	If tsk.predecessor.Length > 0 Then sb.Append("predecessor: ").Append(InQuotes(tsk.predecessor)).append(",")
	If TaskResourceMap.ContainsKey("tsk_" & tsk.taskID) = True Then sb.Append("resourceId: ").Append(BuildTaskResources(tsk.taskID)).Append(",")
	If sb.ToString.EndsWith(",") = True Then sb.Remove(sb.Length-1,sb.Length)
	sb.Append("}")
	Return sb.ToString
End Sub
' runs when an object is created for the first time. Expects a valid html string
' will get surrounded by a div automatically
' in the html file:
Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	iID = internalID
	Return $"<div id="${internalID}" style="width: ${Width}; height: ${Height};"></div>"$
End Sub
' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	'build the chart here and initialize it
	HTML = BuildGantt(internalID)
	InternalPage.ws.Eval(HTML, Array As Object(ABMComp.ID))
	' flush not needed, it's done in the refresh method in the lib
End Sub
'add a holiday to the project
Sub AddHoliday(sday As String, slabel As String, sbackground As String)
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{")
	sb.Append("day: ").Append(InQuotes(sday)).Append(",")
	sb.Append("label: ").Append(InQuotes(slabel)).Append(",")
	sb.Append("background: ").Append(InQuotes(sbackground)).Append("}")
	Holidays.Put(sday,sb.ToString)
End Sub
'add a holiday using the holiday type
Sub AddHoliday1(ht As EventType)
	AddHoliday(ht.day,ht.label,ht.background)
End Sub
'add an event using the event type
Sub AddEvent1(ev As EventType)
	AddEvent(ev.day,ev.label,ev.lineStyle,ev.lineColor,ev.lineWidth)
End Sub
Sub AddEvent(sday As String, slabel As String, slineStyle As String, slineColor As String, slineWidth As String)
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{")
	sb.Append("day: ").Append(InQuotes(sday)).Append(",")
	sb.Append("label: ").Append(InQuotes(slabel)).Append(",")
	sb.Append("lineStyle: ").Append(InQuotes(slineStyle)).Append(",")
	sb.Append("lineColor: ").Append(InQuotes(slineColor)).Append(",")
	sb.Append("lineWidth: ").Append(InQuotes(slineWidth)).Append("}")
	Events.Put(sday,sb.ToString)
End Sub
' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	' use these methods to adjust the object
	' ABM.HasClass
	' ABM.AddClass
	' ABM.RemoveClass
	' ABM.AddHTML
	' ABM.InsertHTMLAfter
	' ABM.RemoveHTML
	' ABM.GetProperty
	' ABM.SetProperty
	' ABM.RemoveProperty
	' ABM.GetStyleProperty
	' ABM.SetStyleProperty
	'set chart properties
End Sub
' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub
private Sub BuildGantt(xid As String) As String
	EditMode = InQuotes(EditMode)
	SelectionMode = InQuotes(SelectionMode)
	SelectionType = InQuotes(SelectionType)
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("$(").Append(QUOTE).Append("#").Append(xid).Append(QUOTE).Append(").ejGantt({").Append(CRLF)
	If allowGanttChartEditing = True Then sb.append("allowGanttChartEditing: true,").Append(CRLF)
	If allowSorting = True Then sb.Append("allowSorting: true,").append(CRLF)
	If allowMultiSorting = True Then sb.Append("allowMultiSorting: true,").Append(CRLF)
	If highlightWeekEnds = False Then sb.Append("highlightWeekEnds: false,").Append(CRLF)
	If enableContextMenu = True Then sb.append("enableContextMenu: true,").append(CRLF)
	If showColumnChooser = True Then sb.append("showColumnChooser: true,").append(CRLF)
	If enableVirtualization = True Then sb.append("enableVirtualization: true,").append(CRLF)
	If includeWeekend = False Then sb.append("includeWeekend: false,").append(CRLF)
	If enableProgressBarResizing = False Then sb.append("enableProgressBarResizing: false,").append(CRLF)
	If allowColumnResize = True Then sb.Append("allowColumnResize: true,").Append(CRLF)
	If showColumnOptions = True Then sb.append("showColumnOptions: true,").append(CRLF)
	If enableAltRow = False Then sb.append("enableAltRow: false,").append(CRLF)
	If RowHeight > 0 Then sb.Append("rowHeight: ").Append(RowHeight).Append(",").Append(CRLF)
	If allowSelection = False Then sb.append("allowSelection: false,").append(CRLF)
	sb.Append("selectionMode: ").Append(SelectionMode).append(",").Append(CRLF)
	sb.Append("selectionType: ").Append(SelectionType).Append(",").Append(CRLF)
	If RenderBaseLine = True Then sb.Append("renderBaseline: true,").Append(CRLF)
	If showResourceNames = True Then sb.Append("showResourceNames: true,").Append(CRLF)
	If enableTaskbarTooltip = True Then sb.append("enableTaskbarTooltip: true,").append(CRLF)
	If enableTaskbarDragTooltip = True Then sb.append("enableTaskbarDragTooltip: true,").append(CRLF)
	If showGridCellTooltip = True Then sb.append("showGridCellTooltip: true,").append(CRLF)
	If showExpandGridCellTooltip = True Then sb.append("showExpandGridCellTooltip: true,").append(CRLF)
	If allowKeyboardNavigation = True Then sb.append("allowKeyboardNavigation: true,").append(CRLF)
	If allowMultipleExporting = True Then sb.append("allowMultipleExporting: true,").append(CRLF)
	If showProgressStatus = True Then sb.append("showProgressStatus : true,").append(CRLF)
	If enablePredecessorValidation = False Then sb.append("enablePredecessorValidation: false,").append(CRLF)
	If baseLineColor.Length > 0 Then sb.Append("baselineColor: ").Append(InQuotes(baseLineColor)).Append(",").append(CRLF)
	If dateFormat.Length > 0 Then sb.Append("dateFormat: ").Append(InQuotes(dateFormat)).Append(",").Append(CRLF)
	If isResponsive = True Then sb.Append("isResponsive: true,").Append(CRLF)
	If splitterIndex.Length > 0 Then sb.Append("splitterSettings: {index : ").Append(InQuotes(splitterIndex)).Append("},").Append(CRLF)
	If enableWBS = True Then sb.Append("enableWBS: true,").Append(CRLF)
	If enableWBSPredecessor = True Then sb.Append("enableWBSPredecessor: true,").Append(CRLF)
	'If ProjectTasksType.Length > 0 Then sb.Append("taskType: ").Append(ProjectTasksType).Append(",").Append(CRLF)
	'If taskSchedulingMode.Length > 0 Then sb.Append("taskSchedulingMode: ").Append(taskSchedulingMode).Append(",").Append(CRLF)
	If showTaskNames = False Then sb.Append("showTaskNames: true,").Append(CRLF)
	If ReadOnly = True Then sb.Append("readOnly: true,").Append(CRLF)
	If treeColumnIndex <> 0 Then sb.Append("treeColumnIndex: ").Append(treeColumnIndex).Append(",").Append(CRLF)
	'If workingTimeScale <> EnumworkingTimeScale.TimeScale8Hours Then sb.Append("workingTimeScale: ").Append(workingTimeScale).Append(",").Append(CRLF)
	Dim ts As String = ""
	Select Case TimeScale
		Case EnumTimeScale.dayMode
			ts = $"scheduleHeaderSettings: {
			scheduleHeaderType: ej.Gantt.ScheduleHeaderType.Day,
			dayHeaderFormat: "dd,MM,yyyy",
			hourHeaderFormat: "HH",
			},"$
			sb.Append(ts).Append(CRLF)
		Case EnumTimeScale.hourMode
		Case EnumTimeScale.monthMode
			ts = $"scheduleHeaderSettings: {
			scheduleHeaderType: ej.Gantt.ScheduleHeaderType.Month,
			monthHeaderFormat: "MMM yyyy",
			weekHeaderFormat: "dd/MM",
			},"$
			sb.Append(ts).Append(CRLF)
		Case EnumTimeScale.weekMode
			ts = $"scheduleHeaderSettings: {
			scheduleHeaderType: ej.Gantt.ScheduleHeaderType.Week,
			weekHeaderFormat: "dd MMM, yyyy",
			dayHeaderFormat: "d",
			},"$
			sb.Append(ts).Append(CRLF)
		Case EnumTimeScale.yearMode
			ts = $"scheduleHeaderSettings: {
			scheduleHeaderType: ej.Gantt.ScheduleHeaderType.Year,
			yearHeaderFormat: "yyyy",
			monthHeaderFormat: "MMM",
			},"$
			sb.Append(ts).Append(CRLF)
	End Select
	If ShowTaskLabels = True Then
		Dim b As String
		b = $"rightTaskLabelMapping: "taskName", leftTaskLabelMapping: "taskID","$
		sb.Append(b).Append(CRLF)
	End If
	If allowDragAndDrop = True Then
		Dim a As String
		a = $"allowDragAndDrop: true, dragTooltip: {showTooltip: true},"$
		sb.Append(a).Append(CRLF)
	End If
	If ShowToolBar = True Then
		Dim s As String
		s = $"toolbarSettings: {showToolbar: true,
		toolbarItems: [ej.Gantt.ToolbarItems.Add,
		ej.Gantt.ToolbarItems.Edit,
		ej.Gantt.ToolbarItems.Delete,
		ej.Gantt.ToolbarItems.Update,
		ej.Gantt.ToolbarItems.Cancel,
		ej.Gantt.ToolbarItems.Indent,
		ej.Gantt.ToolbarItems.Outdent,
		ej.Gantt.ToolbarItems.ExcelExport,
		ej.Gantt.ToolbarItems.CriticalPath,
		ej.Gantt.ToolbarItems.ExpandAll,
		ej.Gantt.ToolbarItems.CollapseAll,
		ej.Gantt.ToolbarItems.PrevTimeSpan,
		ej.Gantt.ToolbarItems.NextTimeSpan]},
		editSettings: {allowEditing: ${allowEditing},allowIndent: ${allowIndent}, allowOutdent: ${allowOutdent}, allowAdding: ${allowAdding},allowDeleting: ${allowDeleting},editMode: ${EditMode}},"$
		sb.Append(s).Append(CRLF)
	End If
	sb.append("sizeSettings:{ width:'100%', height:'100%' },").append(CRLF)
	If Tasks.Size - 1 >= 0 Then
		sb.append("dataSource: ").Append(BuildTasks).Append(",").Append(CRLF)
	End If
	If Resources.Size -1 >= 0 Then
		sb.append("resources: ").Append(BuildResources).Append(",").Append(CRLF)
	End If
	If scheduleStartDate.Length > 0 Then
		sb.Append("scheduleStartDate: ").Append(InQuotes(scheduleStartDate)).Append(",").Append(CRLF)
	End If
	If scheduleEndDate.Length > 0 Then
		sb.Append("scheduleEndDate: ").Append(InQuotes(scheduleEndDate)).Append(",").Append(CRLF)
	End If
	If Events.Size - 1 >= 0 Then
		sb.Append("stripLines: ").Append(BuildEvents).Append(",").Append(CRLF)
	End If
	If HideHolidays = True Then Holidays.Initialize
	If Holidays.Size - 1 >= 0 Then
		sb.Append(" holidays: ").Append(BuildHolidays).Append(",").Append(CRLF)
	End If
	sb.append("load: function(args){").append(CRLF)
	sb.append("var columns = this.getColumns();").Append(CRLF)
	sb.Append("console.log(columns);").Append(CRLF)
	If enableWBS = True Then
		sb.Append("var wbsIndex = columns.map(function(e) { return e.field; }).indexOf('WBS');").Append(CRLF)
		sb.Append("var wbsColumn = columns[wbsIndex];").append(CRLF)
		sb.append("columns.splice(wbsIndex, 1);").append(CRLF)
		sb.append("columns.splice(1, 0, wbsColumn);").append(CRLF)
	End If
	'put the resource field after predecessor
	sb.Append("var resIndex = columns.map(function(e) { return e.field; }).indexOf('resourceInfo');").Append(CRLF)
	sb.Append("var resColumn = columns[resIndex];").append(CRLF)
	sb.append("columns.splice(resIndex, 1);").append(CRLF)
	sb.Append("var prdIndex = columns.map(function(e) { return e.field; }).indexOf('predecessor');").Append(CRLF)
	sb.append("columns.splice(prdIndex+1, 0, resColumn);").append(CRLF)
	If HideNotes = True Then
		sb.Append("var ntsIndex = columns.map(function(e) { return e.field; }).indexOf('notesText');").Append(CRLF)
		sb.append("columns.splice(ntsIndex, 1);").append(CRLF)
	End If
	If HideProgress = True Then
		sb.Append("var prgIndex = columns.map(function(e) { return e.field; }).indexOf('status');").Append(CRLF)
		sb.append("columns.splice(prgIndex, 1);").append(CRLF)
	End If
	If HidePredecessor = True Then
		sb.Append("var prdIndex = columns.map(function(e) { return e.field; }).indexOf('predecessor');").Append(CRLF)
		sb.append("columns.splice(prdIndex, 1);").append(CRLF)
	End If
	If ShowTaskMode = True Then
		sb.Append("var tskModeIndex = columns.map(function(e) { return e.field; }).indexOf('taskMode');").Append(CRLF)
		sb.Append("if (tskModeIndex != -1) {columns[tskModeIndex].visible = true};").Append(CRLF)
	End If
	If ShowWork = True Then
		sb.Append("var workIndex = columns.map(function(e) { return e.field; }).indexOf('work');").Append(CRLF)
		sb.Append("if (workIndex != -1) {columns[workIndex].visible = true};").Append(CRLF)
	End If
	If ShowTaskType = True Then
		sb.Append("var tskTypeIndex = columns.map(function(e) { return e.field; }).indexOf('taskType');").Append(CRLF)
		sb.Append("if (tskTypeIndex != -1) {columns[tskTypeIndex].visible = true};").Append(CRLF)
	End If
	If ShowEffort = True Then
		sb.Append("var effortIndex = columns.map(function(e) { return e.field; }).indexOf('effortDriven');").Append(CRLF)
		sb.Append("if (effortIndex != -1) {columns[effortIndex].visible = true};").Append(CRLF)
	End If
	sb.append("},").append(CRLF)
	Dim x As String
	x = $"taskIdMapping: "taskID",
	milestoneMapping: "milestone",
	parentTaskIdMapping: "pId",
	taskNameMapping: "taskName",
	startDateMapping: "startDate",
	endDateMapping: "endDate",
	durationMapping: "duration",
	progressMapping: "progress",
	childMapping: "subtasks",
	predecessorMapping: "predecessor",
	baselineStartDateMapping: "baselineStartDate",
	baselineEndDateMapping: "baselineEndDate",
	resourceInfoMapping: "resourceId",
	resourceNameMapping: "resourceName",
	resourceIdMapping: "resourceId",
	notesMapping: "notes"
	});"$
	sb.Append(x).Append(CRLF)
	Return sb.tostring
End Sub
